REM $INCLUDE: 'fastgraf.bi'

DEFINT A-Z

DECLARE FUNCTION RandomNumber(Min,Max)

OldMode = FGgetmode
NewMode = FGautomode
FGsetmode NewMode

IF NewMode = 4 THEN
   MaxColor = 3
ELSEIF NewMode = 11 OR NewMode = 17 THEN
   MaxColor = 1
ELSEIF NewMode = 19 THEN
   MaxColor = 255
ELSE
   MaxColor = 15
END IF

Left = 100
MaxX = FGgetmaxx - 1
MaxY = FGgetmaxy - 1

WHILE Left > 0

   X = RandomNumber(1,MaxX)
   Y = RandomNumber(1,MaxY)

   Area = FGgetpixel(X-1,Y-1) + FGgetpixel(X,Y-1) + FGgetpixel(X+1,Y-1) _
        + FGgetpixel(X-1,Y)   + FGgetpixel(X,Y)   + FGgetpixel(X+1,Y) _
        + FGgetpixel(X-1,Y+1) + FGgetpixel(X,Y+1) + FGgetpixel(X+1,Y+1)

   IF Area = 0 THEN
      PointColor = RandomNumber(1,MaxColor)
      FGsetcolor PointColor
      FGpoint X, Y
      Left = Left - 1
   END IF

WEND

FGwaitkey

FGsetmode OldMode
FGreset

END


FUNCTION RandomNumber(Min,Max)

Temp = RND * 32767
RandomNumber = (Temp MOD (Max-Min+1)) + Min

END FUNCTION
