'This TYPE definition is exactly 256 bytes.  If the /AH switch is
'used when entering QB or when compiling with BC then all your
'dialog boxes will be held outside of QuickBASIC 64K data segment.
'Your arrays must be $DYNAMIC.

DECLARE SUB DiaLogic (DB() AS ANY, LB() AS ANY, Action%, Focus%, Ky$)
DECLARE SUB InitMouse (There%)
DECLARE SUB ShowCursor ()
DECLARE SUB TextCursor (FG%, BG%)
DECLARE SUB HideCursor ()

TYPE DialogType
   BorderType AS INTEGER
   Code AS INTEGER
   Default AS INTEGER
   Height AS INTEGER
   ItemLength AS INTEGER
   KeyColor AS INTEGER
   Link AS INTEGER
   NumberOne AS INTEGER
   NumberTwo AS INTEGER
   PrimaryColor AS INTEGER
   SecondaryColor AS INTEGER
   SelectedColor AS INTEGER
   StarColor AS INTEGER
   Text AS STRING * 82
   TextColor AS INTEGER
   TextString AS STRING * 134
   TextX AS INTEGER
   TextY AS INTEGER
   Wdth AS INTEGER
   WindowColor AS INTEGER
   X AS INTEGER
   Y AS INTEGER
END TYPE


'These array types are for internal string arrays.  Each is a total of a
'  power of 2-bytes so that the strings may properly cross 64K blocks.

TYPE DialogText
   Text AS STRING * 256
END TYPE

TYPE DialogTextSmall
   Text AS STRING * 128
END TYPE
