'FILE-MAN.BAS

'Consecutive to wait1

'First, initialize Esc key.

b$=CHR$(27)

'                    Set up window and print intro screen.


SCREEN #1 TEXT:WINDOW CURSOR ON:WINDOW FULL
WINDOW TITLE "The Locomotive BASIC 2 File Manager, Version 2.03
PRINT "                             By Matt Roberts
PRINT "                             5 Cedar St., #8
PRINT "                           Montpelier, Vt 05602
PRINT "                              (802)223-2553
PRINT
PRINT
PRINT "  If you find the programs on this disk useful, a donation of $5.00 would
PRINT "                     be gratefully accepted.  Thanks.
PRINT
PRINT
PRINT "         If you're having trouble using this program, you can call
PRINT "              between 9AM and 9PM (EST), and I'll try to help.
PRINT
PRINT
PRINT
PRINT
PRINT
PRINT "Press any key to continue. ";
GOSUB continue

'Window is now set up.



'            Now direct the program to create a menu of options.

'                       Here is the menu of options.

LABEL menu

CLS
WINDOW TITLE "Your Options

PRINT "F1- List files.";"                               F9- Work with AUTOEXEC.BAT.":PRINT
PRINT "F2- Display file contents.";"                    F10- Get file length.":PRINT
PRINT "F3- Print a file.";"                             <Alt-F1>- Make directory.":PRINT
PRINT "F4- Copy a file.";"                              <Alt-F2>- Remove Directory.":PRINT
PRINT "F5- Move a file.";"                              <Alt-F3>- Get time/date.":PRINT
PRINT "F6- Rename files.";"                             <Alt-F4>- Leave the program.":PRINT
PRINT "F7- Delete files.";"                             <Alt-F5>- Leave BASIC 2.":PRINT
PRINT "F8- Work with CONFIG.SYS file."
PRINT
PRINT
PRINT "Please press the key corresponding to your choice. ";

LABEL wait1
a=INKEY
IF a=315 GOTO seefiles
IF a=316 GOTO displafl
IF a=317 GOTO printfil
IF a=318 GOTO copyfile
IF a=319 GOTO movefile
IF a=320 GOTO renfile
IF a=321 GOTO killfile
IF a=322 GOTO changecon
IF a=323 GOTO chngauto
IF a=324 GOTO filength
IF a=360 GOTO makedir
IF a=361 GOTO removdir
IF a=362 GOTO timedate
IF a=363 GOTO quitprog
IF a=364 GOTO quitbasc
GOTO wait1
GOTO menu
'
'This is the end of the menu.
'
'
'
'           Here is the routine for looking at available files.
'
LABEL seefiles
ON ERROR GOTO error1
PRINT CHR$(27)+"p"
PRINT AT (1;1) "F1- List files.
LABEL seeflagn
CLS RESET
WINDOW TITLE "View Your Files
PRINT "If you're not sure what to do at this point, or if you run into
PRINT "trouble getting the program to show you the files you want, press H;
PRINT "then press Enter.":PRINT:PRINT
INPUT "Which directory";directory$
IF directory$="h" OR directory$="H" THEN GOTO viewhelp
IF directory$=CHR$(13) THEN FILES:GOTO skip
FILES directory$
LABEL skip
PRINT:PRINT:INPUT "Would you like to view more files (y/n)";viewmore$
IF viewmore$="y" OR viewmore$="Y" GOTO seeflagn ELSE GOTO menu
'
'This is the end of the routine for looking at available files.
'
'
'
'          Here is the routine for changing the CONFIG.SYS file.
'
LABEL changecon
ON ERROR GOTO error2
PRINT CHR$(27)+"p"
PRINT AT (1;15) "F8- Work with CONFIG.SYS file.
CLS RESET
WINDOW TITLE "View or Change Your CONFIG.SYS File
INPUT "On which drive is your CONFIG.SYS file";drive$
LABEL redrive
DRIVE drive$
CD\
LABEL confmenu
CLS
PRINT "You have the following options:":PRINT:PRINT
PRINT "1- Just view the CONFIG.SYS file.":PRINT
PRINT "2- Add lines to the end of your file.":PRINT
PRINT "3- Create a new CONFIG.SYS file.":PRINT
PRINT "4- Return to the options menu.":PRINT:PRINT:PRINT
INPUT "Please press the number corresponding to your choice, and then press Enter. ",chngview$
IF chngview$="1" THEN PRINT CHR$(27)+"p":PRINT AT (1;4) "1- Just view the CONFIG.SYS file.":CLS RESET:GOSUB seesys:GOTO confmenu
IF chngview$="2" THEN PRINT CHR$(27)+"p":PRINT AT (1;6) "2- Add lines to the end of your file.":CLS RESET:GOSUB appendln:GOSUB seesys:GOTO confmenu
IF chngview$="3" THEN PRINT CHR$(27)+"p":PRINT AT (1;8) "3- Create a new CONFIG.SYS file.":CLS RESET:GOTO newfilec:GOTO confmenu
IF chngview$="4" THEN PRINT CHR$(27)+"p":PRINT AT (1;10) "4- Return to the options menu.":CLS RESET:GOTO menu
GOTO confmenu
'
'
'
'This section creates new CONFIG.SYS file.
'
LABEL newfilec
CLS
REN config.sys config.bas
PRINT:PRINT:PRINT "Your CONFIG.SYS file has been changed to CONFIG.BAS in order to save
PRINT "it for future use.  To use it later, it will have to be renamed to
PRINT "CONFIG.SYS, after the current CONFIG.SYS has been renamed to
PRINT "something else (for example, config.x).":PRINT:PRINT:PRINT
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
LABEL changeagn
CLS
OPEN #3, OUTPUT "config.sys"
PRINT "How many files do you want (if you're not sure, type 20)?
INPUT "To quit, press Q and Enter. ",filenumb$
IF filenumb$="q" OR filenumb$="Q" THEN GOTO restorec
PRINT #3, "files=";filenumb$
PRINT:PRINT:PRINT
INPUT "How many buffers do you want (if you're not sure, type 5)";buffers$
PRINT #3, "buffers=";buffers$
GOSUB listsys
LABEL devcagain
PRINT:INPUT "Which device would you like to include (N for none)";device$
IF device$="n" OR device$="N" THEN GOTO nodevice
PRINT #3, "devices=";device$
PRINT:INPUT "Would you like to include more devices";incldmore$:IF incldmore$="y" OR incldmore$="Y" THEN GOTO devcagain
LABEL nodevice
PRINT:INPUT "Do you want Break on or off (if not sure, type OFF)";breakyn$
IF breakyn$="on" OR breakyn$="ON" THEN PRINT #3, "break=on"
CLOSE #3
GOSUB seesys:PRINT:PRINT:PRINT
PRINT "If this is not O.K. AND you want to go back and change the file, press C and Enter.":PRINT
PRINT "To restore your original CONFIG.SYS file, press R and Enter.":PRINT
INPUT "If you're happy with it as is, type OK and Enter. ",change$
LABEL okdecide
IF change$="c" OR change$="C" GOTO changeagn
IF change$="r" OR change$="R" THEN GOTO restorec
IF change$="ok" OR change$="OK" THEN GOTO confmenu
PRINT:INPUT "You must choose between C, R, or OK. ",change$:GOTO okdecide
'
'
LABEL restorec
CLS
CLOSE #3
DEL config.sys
REN config.bas config.sys
PRINT "Your original config.sys file has been restored.":PRINT:PRINT "Press any key to continue. ";:GOSUB continue:GOTO confmenu
'
'This is the end of the routine for working with the CONFIG.SYS file.
'
'
'
'       Here is the routine for working with the AUTOEXEC.BAT file.
'
LABEL chngauto
ON ERROR GOTO error3
PRINT CHR$(27)+"p"
PRINT AT (47;1) "F9- Work with AUTOEXEC.BAT."
CLS RESET
WINDOW TITLE "View or Change Your AUTOEXEC.BAT File
INPUT "On which drive is your AUTOEXEC.BAT file";drive$
LABEL redrivea
DRIVE drive$
CD\
LABEL automenu
CLS
PRINT "You have the following options:":PRINT:PRINT
PRINT "1- Just view the AUTOEXEC.BAT file.":PRINT
PRINT "2- Add lines to the end of your file.":PRINT
PRINT "3- Create a new AUTOEXEC.BAT file.":PRINT
PRINT "4- Return to the options menu.":PRINT:PRINT:PRINT
INPUT "Please press the number corresponding to your choice, and then press Enter. ",chngauto$
IF chngauto$="1" THEN PRINT CHR$(27)+"p":PRINT AT (1;4) "1- Just view the AUTOEXEC.BAT file.":CLS RESET:GOSUB autolook:GOTO automenu
IF chngauto$="2" THEN PRINT CHR$(27)+"p":PRINT AT (1;6) "2- Add lines to the end of your file.":CLS RESET:GOSUB appndaut:GOSUB autolook:GOTO automenu
IF chngauto$="3" THEN PRINT CHR$(27)+"p":PRINT AT (1;8) "3- Create a new AUTOEXEC.BAT file.":CLS RESET:GOTO newauto
IF chngauto$="4" THEN PRINT CHR$(27)+"p":PRINT AT (1;10) "4- Return to the options menu.":CLS RESET:GOTO menu
GOTO automenu
'
'
'
'This routine creates a new AUTOEXEC.BAT file.
'
LABEL newauto
REN autoexec.bat autoexec.bas
CLS
PRINT "Your AUTOEXEC.BAT file has been changed to AUTOEXEC.BAS in order to
PRINT "save it for later use.  To use it later, you will have to
PRINT "rename it AUTOEXEC.BAT after renaming the current AUTOEXEC.BAT to
PRINT "something else (for example, autoexec.x).":PRINT:PRINT
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
LABEL scndchng
CLS
OPEN #3 OUTPUT "autoexec.bat
PRINT "Please type the first line you want, then press Enter (Q to quit).
PRINT:INPUT "> ",firstln$
IF firstln$="q" OR firstln$="Q" THEN GOTO nochange
PRINT #3, firstln$
LABEL contline
PRINT:PRINT "Please type your next line, followed by Enter (Q to quit)
PRINT:INPUT "> ", nextline$
IF nextline$="q" OR nextline$="Q" THEN GOTO stopchng
PRINT #3, nextline$
GOTO contline
LABEL stopchng
CLOSE #3
CLS
GOSUB autolook:PRINT:PRINT:PRINT
PRINT "If this is not O.K. AND you want to change it, press C and then Enter.":PRINT
PRINT "To restore your original autoexec.bat, press R and then Enter.":PRINT
INPUT "If you're happy with it as is, type OK and Enter. ",changeyn$
LABEL rechange
IF changeyn$="c" OR changeyn$="C" THEN GOTO scndchng
IF changeyn$="r" OR changeyn$="R" THEN GOTO nochange
IF changeyn$="ok" OR changeyn$="OK" THEN GOTO automenu
PRINT:INPUT "You must choose C, R, or OK. ",changeyn$:GOTO rechange
LABEL nochange
CLS
CLOSE #3
DEL autoexec.bat
REN autoexec.bas autoexec.bat
PRINT "Your original AUTOEXEC.BAT file has been restored.":PRINT:PRINT "Press any key to continue. ";:GOSUB continue:GOTO automenu
'
'This is the end of the routine for working with the AUTOEXEC.BAT file.
'
'
'
'                 Here is the routine for deleting files.
'
LABEL killfile
ON ERROR GOTO error4
PRINT CHR$(27)+"p"
PRINT AT (1;13) "F7- Delete files.
CLS RESET
WINDOW TITLE "Delete Files
PRINT "Before going any further, you should be aware that, once a file has
PRINT "been deleted, it is very difficult to retrieve it.  From this program,
PRINT "it is impossible; there is no undelete option available.":PRINT
LABEL deletagn
INPUT "Press Enter to continue, or Q and Enter to quit. ",contyn$
IF contyn$="q" OR contyn$="Q" GOTO menu
CLS
INPUT "File to delete (include drive and path)";file$
PRINT:PRINT:PRINT "All the data in "UPPER$(file$)" will be destroyed.":PRINT:PRINT
INPUT "Press Enter to continue or Q and Enter to quit ",contyn$
IF contyn$="q" OR contyn$="Q" GOTO menu
KILL file$
PRINT:PRINT:PRINT UPPER$(file$)" has been deleted.":PRINT
INPUT "Delete another";delagain$
IF delagain$="y" OR delagain$="Y" THEN GOTO deletagn
PRINT:GOTO menu
'
'This is the end of the routine for deleting files.
'
'
'               Here is the routine for making a directory.
'
LABEL makedir
ON ERROR GOTO error5
PRINT CHR$(27)+"p"
PRINT AT (47;5) "<Alt-F1>- Make directory.
CLS RESET
WINDOW TITLE "Make a directory
LABEL makeagain
PRINT "Which drive?"
INPUT "Press Q to quit. ",drive$
IF drive$="q" OR drive$="Q" GOTO menu
LABEL redrivem
DRIVE drive$
PRINT:INPUT "Directory name (include path)";directory$
MKDIR directory$
PRINT:PRINT:PRINT "You have created directory: "UPPER$(directory$):PRINT:PRINT
INPUT "Would you like to make another directory";makeagn$
IF makeagn$="y" OR makeagn$="Y" THEN PRINT:PRINT:GOTO makeagain
GOTO menu
'
'This is the end of the routine for making directories.
'
'
'
'              Here is the routine for removing directories.
'
LABEL removdir
ON ERROR GOTO 0
PRINT CHR$(27)+"p"
PRINT AT (47;7) "<Alt-F2>- Remove directory.
CLS RESET
WINDOW TITLE "Remove a directory
PRINT "Before you can remove a directory, you must remove ALL files in that
PRINT "directory, and its subdirectories.  You must then remove all subdirectories.
PRINT:PRINT
LABEL removagn
INPUT "Which drive (Q and Enter to quit)";drive$
IF drive$="q" OR drive$="Q" GOTO menu
DRIVE drive$
PRINT:INPUT "Directory name (include path) or Q to quit";directory$
LABEL redir
IF directory$="q" OR directory$="Q" GOTO menu
CLS:PRINT "Here are the contents of "UPPER$(directory$):
FILES directory$+"\"
PRINT "If this directory is not empty, you will have to delete any files and
PRINT "remove any subdirectories before you can remove it.
PRINT:PRINT
LABEL rdoptions
PRINT "Here are your options:":PRINT
PRINT "1- Delete directory files.":PRINT
PRINT "2- Remove subdirectories.":PRINT
PRINT "3- Continue.":PRINT
PRINT "4- Return to Main Options Menu.":PRINT
INPUT "Please press the number corresponding to your choice and then press Enter: ",dowhat$
IF dowhat$="1" THEN PRINT CHR$(27)+"p":PRINT AT (1;10) "1- Delete directory files.":CLS RESET:GOTO deldirfl
IF dowhat$="2" THEN PRINT CHR$(27)+"p":PRINT AT (1;12) "2- Remove subdirectories.":CLS RESET:GOTO removagn
IF dowhat$="3" THEN PRINT CHR$(27)+"p":PRINT AT (1;14) "3- Continue.":CLS RESET:GOTO rmdrcont
IF dowhat$="4" THEN PRINT CHR$(27)+"p":PRINT AT (1;16) "4- Return to Main Options Menu.":CLS RESET:GOTO menu
LABEL rmdrcont
RMDIR directory$
PRINT:PRINT:PRINT "You have removed directory: "UPPER$(directory$):PRINT:PRINT
INPUT "Would you like to remove another directory";rdagain$
IF rdagain$="y" OR rdagain$="Y" THEN GOTO removagn
GOTO menu
LABEL deldirfl
CLS:PRINT "Here are the files in "UPPER$(directory$)":":PRINT:PRINT
FILES directory$ +"\"
PRINT:PRINT
INPUT "Which file (include path, Q to quit)";whichfil$
IF whichfil$="q" OR whichfil$="Q" THEN CLS:FILES directory$+"\":PRINT:PRINT:PRINT:PRINT:PRINT:GOTO rdoptions
KILL whichfil$
PRINT:PRINT:PRINT UPPER$(whichfil$) " has been deleted.":PRINT
INPUT "Delete another";another$
IF another$="y" OR another$="Y" THEN GOTO deldirfl ELSE CLS:FILES directory$+"\":PRINT:PRINT:PRINT:PRINT:PRINT:GOTO rdoptions
'
'This is the end of the routine for removing directories.
'
'
'
'                Here is the routine for renaming files.
'
LABEL renfile
ON ERROR GOTO 0
PRINT CHR$(27)+"p"
PRINT AT (1;11) "F6- Rename files.
CLS RESET
WINDOW TITLE "Rename Files
LABEL renamagn
CLS
INPUT "Drive (Press Q to quit)";drive$
IF drive$="q" OR drive$="Q" GOTO menu
LABEL redriver
DRIVE drive$
PRINT:PRINT  "Name of file to change (include path)?
INPUT "Q to quit. ",file1$
IF file1$="q" OR file1$="Q" GOTO menu
PRINT:PRINT "New name for "UPPER$(file1$)" (Q to quit)";:INPUT file2$
IF file2$="q" OR file2$="Q" GOTO menu
LABEL refile
NAME file1$ AS  file2$
PRINT:PRINT UPPER$(file1$)" has been renamed "UPPER$(file2$)
PRINT:INPUT "Rename another";renagain$
IF renagain$="y" OR renagain$="Y" THEN GOTO renamagn
GOTO menu
'
'
'This is the end of the routine for renaming files.
'
'
'            Here is the routine for displaying file contents.
'
LABEL displafl
ON ERROR GOTO error8
PRINT CHR$(27)+"p"
PRINT AT (1;3) "F2- Display file contents.
CLS RESET
LABEL displagn
CLS
WINDOW TITLE "View File Contents
PRINT "Which file (include drive and path)?"
INPUT "Press Q and Enter to quit. ",whatfile$
IF whatfile$="q" OR whatfile$="Q" GOTO menu
CLS
PRINT "To pause, press Ctrl-S.
PRINT:PRINT "Special characters used in ";UPPER$(whatfile$)
PRINT "may not print in exactly the same manner as in the original.
PRINT:PRINT "Also, formatting may not be quite correct.
LABEL refiledf
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
CLS
DISPLAY whatfile$
PRINT:INPUT "Do you want to view more files";viewmore$
IF viewmore$="y" OR viewmore$="Y" THEN GOTO displagn
GOTO menu
'
'This is the end of the routine for displaying files.
'
'
'                Here is the routine for copying a file.
'
LABEL copyfile
ON ERROR GOTO error9
PRINT CHR$(27)+"p"
PRINT AT (1;7) "F4- Copy a file.
LABEL redo
CLS RESET
WINDOW TITLE "Copy File
PRINT "*****PLEASE NOTE***** .EXE and .COM files will not copy properly.  While
PRINT "other files have not yet been tested, it is probably safe to assume that"
PRINT "any file that contains special characters may not copy properly.  As
PRINT "far as I know, the original is not affected, but I'm making no guarantees"
PRINT "on that score, either.  Please use backups for any testing, until you
PRINT "are confident that things will go smoothly.
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
LABEL copymore
CLS
PRINT "File to copy (include drive and path)?
INPUT "Press Q to quit. ",sourcefl$
LABEL resource
IF sourcefl$="q" OR sourcefl$="Q" GOTO menu
OPEN #3 INPUT sourcefl$
PRINT:PRINT "Destination (include drive and path)?
INPUT "Press Q to quit. ",destiny$
IF destiny$="q" OR destiny$="Q" THEN CLOSE #3:GOTO menu
IF FIND$(destiny$)<>"" THEN ERROR 135
LABEL goahead
OPEN #4 OUTPUT destiny$
   WHILE NOT EOF(#3)
     LINE INPUT #3, line$
     PRINT #4, line$
   WEND
CLOSE
PRINT:PRINT:PRINT UPPER$(sourcefl$)" has been copied to "UPPER$(destiny$)"."
PRINT
INPUT "Copy another";copyagn$
IF copyagn$="y" OR copyagn$="Y" THEN GOTO copymore
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
GOTO menu
'
'
'This is the end of the routine for copying a file.
'
'
'
'         Here is the routine for getting the length of the file.
'
LABEL filength
ON ERROR GOTO error10
PRINT CHR$(27)+"p"
PRINT AT (47;3) "F10- Get file length.
CLS RESET
WINDOW TITLE "Get File Length
LABEL lngthagn
PRINT "File name (include drive and path)?
INPUT "Press Q to quit. ",filename$
LABEL relength
IF filename$="q" OR filename$="Q" GOTO menu
OPEN #3 INPUT filename$
PRINT:PRINT UPPER$(filename$)" contains "LOF(#3)" bytes.
CLOSE
PRINT:INPUT "Check another file";another$
IF another$="y" OR another$="Y" THEN GOTO lngthagn ELSE GOTO menu
'
'This is the end of the routine for getting file length.
'
'
'                  Here is the routine for moving files.
'
LABEL movefile
ON ERROR GOTO error11
PRINT CHR$(27)+"p"
PRINT AT (1;9) "F5- Move a file.
CLS RESET
WINDOW TITLE "Move File
LABEL remove
PRINT "*****WARNING*****  THIS IS A DESTRUCTIVE FUNCTION.  THAT IS TO SAY, YOUR
PRINT "ORIGINAL COPY WILL BE DESTROYED IN THE NORMAL OPERATION OF THIS OPTION.
PRINT ".EXE AND .COM FILES ARE AMONG THOSE THAT WILL NOT MOVE CORRECTLY.  THERE
PRINT "ARE PROBABLY OTHERS.  PLEASE USE BACKUP FILES FOR EXPERIMENTING, UNTIL
PRINT "YOU ARE CERTAIN THAT THINGS WILL GO AS PLANNED.  AGAIN, DO NOT TRY TO
PRINT "MOVE .COM OR .EXE FILES USING THIS OPTION.":PRINT:PRINT
LABEL moveagn
INPUT "To quit, press Q; then press Enter.  To continue, just press Enter. ",quityn$
IF quityn$="q" OR quityn$="Q" GOTO menu
CLS
PRINT "Please type the path where the file you want to move can be found.  Don't
PRINT "include the name of the file yet.  If you want to quit, press Q; then press
INPUT "Enter. ",path$
IF path$="q" OR path$="Q" GOTO menu
PRINT:INPUT "Please enter the filename.  To quit, Press Q and Enter. ",filename$
IF filename$="q" OR filename$="Q" GOTO menu
wholenam$=path$+"\"+filename$
PRINT:PRINT "Please type the new location for ";UPPER$(wholenam$);".
PRINT "Again, don't type the name of the file.  The old filename will be used.
INPUT "To quit, press Q. ",newplace$
IF newplace$="q" OR newplace$="Q" GOTO menu
LABEL rewhole
newfile$=newplace$+"\"+filename$
IF FIND$(newfile$)<>"" THEN ERROR 135
LABEL moveon
OPEN #3 INPUT wholenam$
LABEL renew
OPEN #4 OUTPUT newfile$
   WHILE NOT EOF(#3)
     LINE INPUT #3, line$
     PRINT #4, line$
   WEND
CLOSE
KILL wholenam$
PRINT:PRINT
PRINT UPPER$(wholenam$)" has been moved to "UPPER$(newfile$)
INPUT "Move another";moveagn$
IF moveagn$="y" OR moveagn$="Y" THEN GOTO moveagn
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
GOTO menu
'
'
'This is the end of the routine for moving files.


'             Here is the routine for getting the time and date.


LABEL timedate
ON ERROR GOTO 0
PRINT CHR$(27)+"p"
PRINT AT (47;9) "<Alt-F3>- Get time/date.
CLS RESET
WINDOW TITLE "Get Time and/or Date
LABEL menutmdt
CLS
PRINT "Here are your options:"
PRINT
PRINT
PRINT
PRINT "1- Get the time."
PRINT
PRINT "2- Get the date."
PRINT
PRINT "3- Get both."
PRINT
PRINT "4- Return to Main Options Menu."
PRINT
PRINT
PRINT
INPUT "Please press the key corresponding to your choice; then press Enter. ",choicetd
ON choicetd GOTO gettime,getdate,getboth,getout

GOTO menutmdt
LABEL gettime

PRINT CHR$(27)+"p"
PRINT AT (1;5) "1- Get the time.
CLS RESET
PRINT "In order for this function to work, the time in your computer must be
PRINT "set properly, either manually or with the Real-Time-Clock."
PRINT
PRINT
PRINT
PRINT
PRINT
a$=TIME$
c$=MID$(a$,1,2)
a=VAL(c$)
IF a>12 THEN g$=" PM" ELSE g$=" AM"
IF a>12 THEN a=a-12
d$=STR$(a)
e$=MID$(a$,3,6)
f$=d$+e$
PRINT "The time is now: ";
PRINT f$;g$
PRINT
PRINT
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
GOTO menutmdt

LABEL getdate

PRINT CHR$(27)+"p"
PRINT AT (1;7) "2- Get the date.
CLS RESET
PRINT "In order for this function to work, the date in your computer must be
PRINT "set properly.  If it isn't, you may get a weird date."
PRINT
PRINT
PRINT
PRINT
PRINT
PRINT "Today's date is ";DATE$
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
GOTO menutmdt

LABEL getboth

PRINT CHR$(27)+"p"
PRINT AT (1;9) "3- Get both.
CLS RESET
PRINT "In order for this function to work, both your time and date must be set
PRINT "properly.  If they aren't, you may get some weird answers.  If you have
PRINT "problems, check your manual to find out how to set the time and date
PRINT "from DOS."
PRINT
PRINT
PRINT
PRINT
PRINT
a$=TIME$
c$=MID$(a$,1,2)
a=VAL(c$)
IF a>12 THEN g$=" PM" ELSE g$=" AM"
IF a>12 THEN a=a-12
d$=STR$(a)
e$=MID$(a$,3,6)
f$=d$+e$
PRINT "The time is now: ";
PRINT f$;g$
PRINT
PRINT
PRINT "Today's date is ";DATE$
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
GOTO menutmdt

LABEL getout
PRINT CHR$(27)+"p"
PRINT AT (1;11) "4- Return to Main Options Menu.
CLS RESET
GOTO menu


'This is the end of the routine for getting the time and date.
'
'
'
'Here is the routine for printing a file.
LABEL printfil
ON ERROR GOTO error12
PRINT CHR$(27)+"p"
PRINT AT (1;5) "F3- Print a file.
CLS RESET
WINDOW TITLE "Print File.
LABEL printagn
CLS
PRINT "This feature may have trouble with some special characters.  If you're
PRINT "printing a text file, you should be able to read it OK.  However, you
PRINT "will probably not get your formatting quite right.  As a result, this
PRINT "feature should be used for draft copies only, rather than copies for
PRINT "presentation.
PRINT
PRINT
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
PRINT
PRINT "File to print (include drive and path)?
INPUT "Press Q and Enter to quit. ",prsource$
IF prsource$="q" OR prsource$="Q" GOTO menu
OPEN #3 INPUT prsource$
LABEL prncont
WHILE NOT EOF(#3)
  LINE INPUT #3, line$
  LPRINT line$
WEND
CLOSE
PRINT
PRINT
INPUT "Print another";printagn$
IF printagn$="y" OR printagn$="Y" THEN GOTO printagn
GOTO menu
'
'
'This is the end of the routine for printing a file.
'
'
'              Here is the routine for leaving the program.
'
LABEL quitprog
PRINT CHR$(27)+"p"
PRINT AT (47;11) "<Alt-F4>- Leave the program.
CLS RESET
WINDOW CURSOR OFF
WINDOW FULL OFF
WINDOW TITLE "Results-1
SCREEN #1 GRAPHICS
END
'
'This is the end of the program exit option.
'
'
'
'    Here is the routine for leaving the program and returning to GEM.
'
LABEL quitbasc
PRINT CHR$(27)+"p"
PRINT AT (47;13) "<Alt-F5>- Leave BASIC 2.
QUIT
'
'This is the end of the BASIC2 exit option.
'
'
'
'
'
'
'         Here is the routine for looking at the CONFIG.SYS file.
'
LABEL seesys
CLS:PRINT "Here is your file:":PRINT
DISPLAY "config.sys
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
RETURN
'
'This is the end of the routine for looking at the CONFIG.SYS file.
'
'
'
'     Here is the routine for adding lines to the end of CONFIG.SYS
'
LABEL appendln

OPEN #3 APPEND  "config.sys
  GOSUB listsys
LABEL appendagn
  PRINT:INPUT "Line to add (Q to quit)";appendln$
    IF appendln$="q" OR appendln$="Q" THEN CLOSE #3:RETURN
  PRINT #3, appendln$
GOTO appendagn
'
'This is the end of the routine for adding lines to CONFIG.SYS.
'
'
'
'       Here is the routine for listing the devices for CONFIG.SYS.
'
LABEL listsys
PRINT:INPUT "Do you want a list of the system devices available (y/n)";list$
IF list$="y" OR list$="Y" THEN CLS:FILES "*.sys":PRINT "(Don't count CONFIG.SYS as a system device)":PRINT:PRINT:RETURN
IF list$="n" OR list$="N" THEN RETURN
PRINT "Please press either Y or N.":GOTO listsys
'
'This is the end of the routine for listing the devices for CONFIG.SYS.
'
'
'
'       Here is the routine for looking at the AUTOEXEC.BAT file.
'
LABEL autolook
CLS
PRINT "Here is your file":PRINT:PRINT
DISPLAY "autoexec.bat
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
RETURN
'
'This is the end of the routine for looking at the AUTOEXEC.BAT file.
'
'
'
'    Here is the routine for adding lines to the end of AUTOEXEC.BAT.
'
LABEL appndaut
OPEN #3 APPEND "autoexec.bat
LABEL appndagn
  PRINT:INPUT "Line to add (Q to quit)";appendln$
    IF appendln$="q" OR appendln$="Q" THEN CLOSE #3:RETURN
  PRINT #3, appendln$
GOTO appndagn
'
'This is the end of the routine for adding to the end of AUTOEXEC.BAT.
'
'
'
'      Here is the subroutine for continuing when the user is ready.
'
LABEL continue
LABEL wait
a$=INKEY$
IF a$="" GOTO wait
RETURN
'
'
'
'              Here is the help file for the file viewing option.
'
LABEL viewhelp
CLS
PRINT "Here are a few tricks to help ensure you're specifying the files you
PRINT "want:":PRINT:PRINT
PRINT "    1- Your `path' should always start with a drive letter, even if
PRINT "you know you're in the drive you want.  While this is not strictly
PRINT "necessary, it does ensure that this part of the syntax is not to
PRINT "blame.  Including the drive letter will never cause problems, but
PRINT "neglecting to include it will, in some cases.":PRINT:PRINT:
PRINT "    2- The name of the directory you want should always start with a
PRINT "`\' symbol.  Be careful not to confuse it with `/'.":PRINT:PRINT
PRINT
PRINT "Press any key to continue. ";
GOSUB continue
CLS
PRINT "    3- If you want to view the files in a particular subdirectory,
PRINT "the name of that directory must end with the `\' symbol.  Otherwise,
PRINT "the program will think you just want to know if the subdirectory
PRINT "exists, and will list it if it does.":PRINT:PRINT
PRINT "Here's an example of correct syntax (grammar) for listing files:":PRINT
PRINT "  c:\pcwrite\catalog\ will tell the program you want to see the files
PRINT "in the catalog subdirectory of the pcwrite directory on the c: drive.
PRINT:PRINT:INPUT "Press Enter to return.",goback$:GOTO seefiles
'
'This is the end of the help routine for the file viewing section.
'
'
'                    Here are the error handling routines.
'
LABEL error1 'These are the error routines for `SEEFILES'
IF ERR=100 THEN GOTO err100sf
'
'
LABEL err100sf
RESUME skip
'
'
LABEL error2 'These are the error routines for changecon
IF ERR=108 THEN GOTO err108cc
IF ERR=134 THEN GOTO err134cc
IF ERR=135 THEN GOTO err135cc
'
'
LABEL err108cc
CLS
PRINT "Hi.  You've entered an invalid drive specification.  Please re-enter
PRINT "the drive letter.  To cancel and return to the options menu, press Q;
INPUT "then press Enter. ",drive$
IF drive$="q" OR drive$="Q" THEN RESUME menu
RESUME
'
'
LABEL err134cc
CLS
PRINT "Hi.  The CONFIG.SYS file can't be found on the drive you've specified.
PRINT "Please re-enter the drive for BASIC 2 to use in looking for your file.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",drive$
IF drive$="q" OR drive$="Q" THEN RESUME menu
RESUME redrive
'
'
LABEL err135cc
CLS
PRINT "Hi.  A file named CONFIG.BAS already exists.  This program renames your
PRINT "CONFIG.SYS file to CONFIG.BAS in order to preserve it for future use.
PRINT "In order to create a new CONFIG.SYS file, it will be necessary to rename
PRINT "the file CONFIG.BAS to some other file, such as CONFIG.X, CONFIG.BAK,
PRINT "or the like.
PRINT:PRINT "In a moment, you'll be returned to the options menu.  From there,
PRINT "you can give CONFIG.BAS some other name, or delete it if you prefer.
PRINT:PRINT:INPUT "Please press Enter to return to the options menu. ",menu$
RESUME menu
'
'
LABEL error3 'These are the error routines for chngauto
IF ERR=108 THEN GOTO err108ca
IF ERR=134 THEN GOTO err134ca
IF ERR=135 THEN GOTO err135ca
'
'
LABEL err108ca
CLS
PRINT "Hi.  You've entered an invalid drive specification.  Please re-enter
PRINT "the drive letter.  To cancel and return to the options menu, press Q;
INPUT "then press Enter. ",drive$
IF drive$="q" OR drive$="Q" THEN RESUME menu
RESUME
'
'
LABEL err134ca
CLS
PRINT "Hi.  The AUTOEXEC.BAT file can't be found on the drive you've specified.
PRINT "Please re-enter the drive letter.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",drive$
IF drive$="q" OR drive$="Q" THEN RESUME menu
RESUME redrivea
'
'
LABEL err135ca
CLS
PRINT "Hi.  A file named AUTOEXEC.BAS already exists.  This program changes
PRINT "your AUTOEXEC.BAT file to AUTOEXEC.BAS to preserve it for future use.
PRINT "In order to create a new AUTOEXEC.BAT file, you'll need to rename
PRINT "AUTOEXEC.BAS to some other file, such as AUTOEXEC.X, AUTOEXEC.BAK, or
PRINT "the like.
PRINT "In a moment, you'll be returned to the options menu.  From there, you can
PRINT "rename AUTOEXEC.BAS, or delete it if you wish.
PRINT:INPUT "Please press Enter to return to the options menu. ",menu$
RESUME menu
'
'
LABEL error4 'These are the error routines for killfile
IF ERR=108 THEN GOTO err108kf
IF ERR=134 THEN GOTO err134kf
'
'
LABEL err108kf
CLS
PRINT "Hi.  You've entered an invalid file specification.  If you're trying
PRINT "to use wildcards, they won't work.  You have to specify each file you
PRINT "want to delete, and delete each separately.
PRINT:PRINT "Please re-enter the filename, and then press Enter.  To cancel
INPUT "and return to the options menu, press Q; then press Enter. ",file$
IF file$="q" OR file$="Q" THEN RESUME menu
RESUME
'
'
LABEL err134kf
CLS
PRINT "Hi.  The file you've specified can't be found.  Please re-enter the filename
PRINT "and then press Enter.
PRINT:PRINT "If you'd like to look at the files on your disk, press L.
PRINT "To cancel and return to the options menu, press Q; then press Enter.
INPUT "Your choice";file$
IF file$="l" OR file$="L" THEN RESUME seeflagn
IF file$="q" OR file$="Q" THEN RESUME menu
RESUME
'
'
LABEL error5 'These are the error routines for makedir
'
IF ERR=108 THEN GOTO err108md
'
'
LABEL err108md
CLS
PRINT "Hi.  You've entered an invalid drive specification.  Please re-enter
PRINT "the drive letter.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",drive$
IF drive$="q" OR drive$="Q" THEN RESUME menu
RESUME redrivem
'
'
LABEL error7 'These are the error routines for renfile
'
IF ERR=108 THEN GOTO err108rf
IF ERR=134 THEN GOTO err134rf
IF ERR=135 THEN GOTO err135rf
'
'
LABEL err108rf
CLS
PRINT "Hi.  You've entered an invalid drive specification.  Please re-enter
PRINT "the drive letter.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",drive$
IF drive$="q" OR drive$="Q" THEN RESUME menu
RESUME redriver
'
'
LABEL err134rf
CLS
PRINT "Hi.  The file you've specified can't be found.  Please re-enter the filename.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",file1$
IF file1$="q" OR file1$="Q" THEN RESUME menu
RESUME refile
'
'
LABEL err135rf
CLS
PRINT "Hi.  The new name you've specified for your file already exists on the
PRINT "drive and directory you've specified.  Please re-enter the new filename.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",file2$
IF file2$="q" OR file2$="Q" THEN RESUME menu
RESUME refile
'
'
LABEL error8 'These are the error routines for displafl
'
IF ERR=108 THEN GOTO err108df
'
'
LABEL err108df
CLS
PRINT "Hi.  You've entered an invalid filename.  Please re-enter it.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",whatfile$
IF whatfile$="q" OR whatfile$="Q" THEN RESUME menu
RESUME refiledf
'
'
LABEL error9 'These are the error routines for copyfile
'
IF ERR=108 THEN GOTO err108cf
IF ERR=134 THEN GOTO err134cf
IF ERR=135 THEN GOTO err135cf
'
'
LABEL err108cf
CLS
PRINT "Hi.  You've entered an invalid filename.  Please try again.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",sourcefl$
CLOSE
RESUME resource
'
'
LABEL err134cf
CLS
PRINT "Hi.  The file you've specified can't be found.  Please try again.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",sourcefl$
IF sourcefl$="q" OR sourcefl$="Q" THEN RESUME menu
RESUME resource
LABEL err135cf
CLS
PRINT "Hi.  A file with the name of ";UPPER$(destiny$)" already exists in your
PRINT "chosen destination.
PRINT
INPUT "Is it OK to overwrite that file";overrite$
IF overrite$="y" OR overrite$="Y" THEN RESUME goahead
IF overrite$="n" OR overrite$="N" THEN CLOSE
RESUME menu
'
'
LABEL error10 'These are the error routines for filength
'
IF ERR=108 THEN GOTO err108fl
IF ERR=134 THEN GOTO err134fl
'
'
LABEL err108fl
CLS
PRINT "Hi.  You've entered an invalid filename.  Please try again.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",filename$
IF filename$="q" OR filename$="Q" THEN RESUME menu
RESUME relength
'
'
LABEL err134fl
CLS
PRINT "Hi.  The file you've specified can't be found.  Please check your path
PRINT "and spelling and try again.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",filename$
RESUME relength
'
'
LABEL error11 'These are the error routines for movefile
'
IF ERR=108 THEN GOTO err108mf
IF ERR=124 THEN GOTO err124mf
IF ERR=134 THEN GOTO err134mf
IF ERR=135 THEN GOTO err135mf
'
'
LABEL err108mf
CLS
PRINT "Hi.  You've entered an invalid filename.  You'll be returned to the
PRINT "start of the routine, and you'll have to start over.  Press Enter when
PRINT "ready.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press
INPUT "Enter. ",staygo$
IF staygo$="q" OR staygo$="Q" THEN RESUME menu
CLS
RESUME remove
'
'
LABEL err124mf
CLOSE
RESUME
'
'
LABEL err134mf
CLS
PRINT "Hi.  ";UPPER$(wholenam$)" can't be found.  Please check your path and
PRINT "spelling and try again.
PRINT:PRINT "To cancel and return to the options menu, press Q; then press Enter.
INPUT "Please re-enter the path. ",path$
IF path$="q" OR path$="Q" THEN RESUME menu
PRINT
INPUT "Please re-enter the filename. ",filename$
IF filename$="q" OR filename$="Q" THEN RESUME menu
wholenam$=path$+"\"+filename$
RESUME rewhole
'
'
LABEL err135mf
CLS
PRINT "Hi.  ";UPPER$(newfile$)" already exists in your chosen destination.
PRINT
INPUT "Is it OK to overwrite that file";overwryn$
IF overwryn$="y" OR overwryn$="Y" THEN RESUME moveon
IF overwryn$="n" OR overwryn$="N" THEN CLOSE
RESUME menu
'
'
'
LABEL error12 'Here are the error routines for printfil
'
IF ERR=108 THEN GOTO err108pf
IF ERR=124 THEN GOTO err124pf
IF ERR=134 THEN GOTO err134pf
'
'
LABEL err108pf
CLS
PRINT "Hi.  You've entered an invalid filename.  Please try again.
PRINT
PRINT "To quit and return to the options menu, press Q; then press
INPUT "Enter. ",prsource$
IF prsource$="q" OR prsource$="Q" THEN RESUME menu
RESUME prcont
'
'
LABEL err124pf
CLOSE
RESUME
'
'
LABEL err134pf
CLS
PRINT "Hi.  ";UPPER$(prsource$)" can't be found.  Please check your spelling
PRINT "and/or path, and try again.
PRINT
PRINT
PRINT "To quit and return to the options menu, press Q; then press
INPUT "Enter. ",prsource$
IF prsource$="q" OR prsource$="Q" THEN RESUME menu
RESUME prncont
