'        ķ
'                            FR-LISA.BAS                    
'        Ľ
'
'     I occasionally  find on  BBSs a  BASICA program  so charming
'     that I  can't help  but try  to improve  somethat  needs  no
'     improvement.   The BASICA  program was  written in  1982 by:
'     "M.L. &  S.C. Anderson."   The  music is  delightful.    The
'     BASICA commands had to be converted to QBASIC in order to be
'     complied.   In BASICA,  all you  need to do is add an "X" in
'     front of  a string variable to play it; in QBASIC it is more
'     difficult.   Especially, since  the QBASIC books have little
'     to say about the PLAY command.  The subroutines are a double
'     random number  generator for  LOCATE and COLOR.  It requires
'     that the  music be  in "MB" (Music Background).  Most of the
'     visual interaction  is with  the use  of  ASCII  characters,
'     screen WIDTH of 40 and the two random number formulas.
'
'     This is shareware.
'           ͸
'                          John R De Palma                
'              March 15, 1991         Remember Big Julie  
'                        CompuServe 76076,571             
'           ;

DECLARE SUB HEADER ()
DECLARE SUB FRAME ()
DECLARE SUB REFRAME ()
DECLARE SUB ROLL6 ()
DECLARE SUB REFRAME2 ()
DECLARE SUB ROLL ()
DECLARE SUB ROLL2 ()
DECLARE SUB ROLL3 ()
DECLARE SUB ROLL4 ()
DECLARE SUB ROLL5 ()
SCREEN 0: WIDTH 40: CLS          ' make the screen 40x25
COLOR 15, 1

'       Draw an outline around screen with ASCII characters.
CLS
LOCATE 1, 2, 0, 0, 0                                ' turn off the cursor

    PRINT CHR$(219); STRING$(35, 223); CHR$(219);   ' Draw top border.
    FOR I = 2 TO 23                                 ' Draw left and right borders.
        LOCATE I, 2
        PRINT CHR$(186); SPACE$(35); CHR$(186);
    NEXT I
    LOCATE 23, 2
    PRINT CHR$(219); STRING$(35, 220); CHR$(219);   ' Draw bottom border.

'       Technique for centering text on the screen

COLOR 14, 7

text$ = SPACE$(22)                          ' Set text length
LOCATE 3, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = "   F  R   E L I S E  "            ' Set text length
LOCATE 4, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = SPACE$(22)                          ' Set text length
LOCATE 5, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text

text$ = "         B  Y         "            ' Set text length
LOCATE 6, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = SPACE$(22)                          ' Set text length
LOCATE 7, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = " Ludwig van Beethoven "            ' Set text length use same variable
LOCATE 8, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print new text
text$ = SPACE$(22)                          ' Set text length
LOCATE 9, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = "                  "            ' Set text length
LOCATE 10, (40 \ 2) - LEN(text$) \ 2 + 1    ' Calculate the center
PRINT text$                                 ' Print text
COLOR 15, 4
text$ = "  Arranged in BASICA by:  "
LOCATE 21, (40 \ 2) - LEN(text$) \ 2 + 1    ' Calculate the center
PRINT text$                                 ' nb: use ";" to keep cursor on

text$ = " M.L. & S.C. Anderson - 1982 "
LOCATE 22, (40 \ 2) - LEN(text$) \ 2 + 1    ' Calculate the center
PRINT text$                                 ' nb: use ";" to keep cursor on
COLOR 11, 0
text$ = "QBASIC by: John De Palma"
LOCATE 24, (40 \ 2) - LEN(text$) \ 2 + 1    ' Calculate the center
PRINT text$;                                ' nb: use ";" to keep cursor on
COLOR 14, 7

FOR J = 11 TO 20                            '  use the ASCII musical note
    LOCATE J, 10 + J + 1
    COLOR J - 3, 1
    PRINT CHR$(14)
    NEXT J

FOR K = 11 TO 20
    LOCATE K, 30 - K + 1
    COLOR K - 3, 1
    PRINT CHR$(14)
    NEXT K

'       Arranged in BASICA by:  M.L. & S.C. Anderson - 1982
'       these "guys" have real talent!

     THEME$ = "MB O4ED+ED+E O3B O4DC O3A O1A O2A O3CEAB O1E O2G+"
     TAG1$ = "MB O3EG+B O4C O1A O2A O3E"
     TAG2$ = "MB O3D O4C O3BA O1A O2A"
     PHRASE1$ = "MB O3B O4CDE O2C O3CG O4FED O1G O2B O3F O4EDC O1A O2A O3E O4DC  O3B O2E MS O3E ML E O4E O3E MS O4E ML E O5E O4D+ED+ED+ED+"
     PHRASE2$ = "MB MS O3A O1AAAAA O4C+ O1AAAAA O4D O1AAA O4EFF O1AAA O4F O1A"
     PLAY "MB ML T64 L16"
     PLAY "X" + VARPTR$(THEME$)
     PLAY "X" + VARPTR$(TAG1$)
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG2$): PLAY "P16"
CALL ROLL
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG1$)
CALL ROLL2
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG2$)
CALL ROLL
     PLAY "X" + VARPTR$(PHRASE1$)
CALL ROLL2
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG1$)
CALL ROLL
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG2$)
CALL ROLL2
     PLAY "X" + VARPTR$(PHRASE1$)
CALL FRAME
CALL ROLL
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG1$)
CALL ROLL2
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG2$)
CALL ROLL
     PLAY "MB MS O4CCC ML O3F64A64 O4C32 O2ACA O4F. MS E32 ML E O2B-"
CALL REFRAME
CALL ROLL
     PLAY "MB O4D O2B- O4B-. MS A32 ML AGFEDC O3 B- O2A O3A O2A"
CALL ROLL5
     PLAY "MB O3 B-64A64 L32 GAB L16 O4C O2A O3C O2A O4DD+E O2A O3C"
CALL ROLL2
     PLAY "MB O4EF O3A O4C O3E O2G O3C O4D. L32 O3B O4CG O3G O4G O3A O4G"
CALL ROLL2
     PLAY "MB O3B O4GCGDGEG O5C O4BAGFEDGFDCG O3G O4G O3A O4G O3B O4GCGDG"
CALL HEADER
     PLAY "MB EG O5C O4BAGFEDGFDEFED+E O3B O4ED+E O3B O4ED+ L8 E. O3B O4ED+E."
     PLAY "L16 O3B O4ED+ED+ED+"
CALL REFRAME2
CALL ROLL
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG1$)
CALL ROLL2
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG2$)
CALL ROLL2
     PLAY "X" + VARPTR$(PHRASE1$)
CALL ROLL2
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG1$)
CALL ROLL5
     PLAY "X" + VARPTR$(THEME$)
CALL REFRAME
CALL ROLL
     PLAY "O3D O4C O3B;"
     PLAY "X" + VARPTR$(PHRASE2$)
CALL ROLL5
     PLAY "O4E O1AAAAA O4D O1AAA O4C O3BA O1AAA O3A O1A O3A O1A O4C"
CALL ROLL2
     PLAY "O1A O3B O1G": PLAY "X" + VARPTR$(PHRASE2$)
CALL ROLL5
     PLAY "O4F O1B-B-B-B-B- O4E- O1B-B-B- O4DC O3B- O1B-B-B- O3A O1B-"
CALL ROLL2
     PLAY "O3G+ O1BBB O3G+ O1B ML O3A4 P8 B8 P4 L24 O2A O3CEA O4CEDC"
CALL REFRAME2
CALL ROLL2
CALL ROLL5
     PLAY "O3BA O4CEA O5CEDC O4BA O5CEA O6CEDC O5BB-AG+GF+FED+DC+C"
CALL ROLL2
     PLAY "O4BB-AG+GF+F L16 ED+E O3B O4DC O3A O2EA O3CEAB O2EG+"
CALL ROLL5
     PLAY "X" + VARPTR$(TAG1$)
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG2$)
CALL REFRAME
     PLAY "X" + VARPTR$(PHRASE1$)
CALL ROLL
     PLAY "X" + VARPTR$(THEME$): PLAY "X" + VARPTR$(TAG1$)
CALL ROLL2
     PLAY "X" + VARPTR$(THEME$): PLAY "O3D O4C O3BA8"
CALL ROLL5
SLEEP 10
WIDTH 40: COLOR 15, 4
CLS

'       Draw an outline around screen with ASCII characters.
CLS
LOCATE 5, 8, 0, 0, 0                                ' turn off the cursor, locates top of box

    PRINT CHR$(201); STRING$(24, 205); CHR$(187);   ' Draw top border.
    FOR I = 6 TO 15                                 ' Draw left and right borders.
        LOCATE I, 8
        PRINT CHR$(186); SPACE$(24); CHR$(186);
    NEXT I
    LOCATE 15, 8
    PRINT CHR$(200); STRING$(24, 205); CHR$(188);   ' Draw bottom border.

'       Technique for centering text on the screen

COLOR 14, 7

text$ = SPACE$(22)                                  ' Set text length
LOCATE 3, (40 \ 2) - LEN(text$) \ 2 + 1             ' Calculate the center
PRINT text$                                         ' Print text
text$ = "   F  R   E L I S E  "                    ' Set text length
LOCATE 4, (40 \ 2) - LEN(text$) \ 2 + 1             ' Calculate the center
PRINT text$                                         ' Print text
text$ = SPACE$(22)                                  ' Set text length
LOCATE 6, (40 \ 2) - LEN(text$) \ 2 + 1             ' Calculate the center
PRINT text$                                         ' Print text

text$ = "         B  Y         "                    ' Set text length
LOCATE 7, (40 \ 2) - LEN(text$) \ 2 + 1             ' Calculate the center
PRINT text$                                         ' Print text
text$ = SPACE$(22)                                  ' Set text length
LOCATE 8, (40 \ 2) - LEN(text$) \ 2 + 1             ' Calculate the center
PRINT text$                                         ' Print text
text$ = " Ludwig van Beethoven "                    ' Set text length use same variable
LOCATE 9, (40 \ 2) - LEN(text$) \ 2 + 1             ' Calculate the center
PRINT text$                                         ' Print new text
text$ = SPACE$(22)                                  ' Set text length
LOCATE 10, (40 \ 2) - LEN(text$) \ 2 + 1            ' Calculate the center
PRINT text$                                         ' Print text
text$ = "    1770  -  1827     "                    ' Add Ludwig's stats
LOCATE 11, (40 \ 2) - LEN(text$) \ 2 + 1            ' Calculate the center
PRINT text$                                         ' Print text

text$ = "       E N D E        "                    ' Set text length
LOCATE 16, (40 \ 2) - LEN(text$) \ 2 + 1            ' Calculate the center
PRINT text$                                         ' Print text
COLOR 15, 4
text$ = "  Arranged in BASICA by:  "
LOCATE 21, (40 \ 2) - LEN(text$) \ 2 + 1            ' Calculate the center
PRINT text$

text$ = " M.L. & S.C. Anderson - 1982 "
LOCATE 22, (40 \ 2) - LEN(text$) \ 2 + 1            ' Calculate the center
PRINT text$
COLOR 11, 0
text$ = "QBASIC by: John De Palma"
LOCATE 24, (40 \ 2) - LEN(text$) \ 2 + 1            ' Calculate the center
PRINT text$;                                        ' nb: use ";" to keep cursor on the same line
COLOR 14, 7
LOCATE 13, 20: COLOR 27, 0: PRINT CHR$(14): SLEEP 3
'       A little "heart" finale
CALL ROLL3
CALL FRAME
CALL ROLL3
CALL ROLL6
CALL REFRAME
CALL ROLL3
CALL ROLL6
CALL REFRAME2
CALL ROLL3
CALL ROLL6
CALL REFRAME2
CALL ROLL3
CALL ROLL4: SLEEP 10: WIDTH 80: COLOR 15, 1: CLS : SYSTEM
                                                    

SUB FRAME
WIDTH 40: COLOR 15, 4
'       REdraw  with hearts ASCII characters.
LOCATE 5, 8, 0, 0, 0                                ' turn off the cursor, locates top of box
WIDTH 40: COLOR 15, 4
LOCATE 5, 8, 0, 0, 0                                ' turn off the cursor, locates top ofbox

    PRINT CHR$(201); STRING$(24, 3); CHR$(187);   ' Draw top border.
    FOR I = 6 TO 15                                 ' Draw left and right borders.
        LOCATE I, 8
        PRINT CHR$(3); SPACE$(24); CHR$(3);
    NEXT I
    LOCATE 15, 8
    PRINT CHR$(200); STRING$(24, 3); CHR$(188);   ' Draw bottom border.

'       Technique for centering text on the screen

COLOR 14, 7

text$ = SPACE$(22)                          ' Set text length
LOCATE 3, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = "   F  R   E L I S E  "            ' Set text length
LOCATE 4, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = SPACE$(22)                          ' Set text length
LOCATE 6, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text

text$ = "         B E I        "            ' Set text length
LOCATE 7, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = SPACE$(22)                          ' Set text length
LOCATE 8, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = " Ludwig van Beethoven "            ' Set text length use same variable
LOCATE 9, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print new text
text$ = SPACE$(22)                          ' Set text length
LOCATE 10, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = "Geboren 1770,  Leipzig"            ' Add Ludwig's stats
LOCATE 11, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text

text$ = " Studentin von Mozart "            ' Set text length
LOCATE 16, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
COLOR 15, 4
text$ = "  Arranged in BASICA by:  "
LOCATE 21, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$

text$ = " M.L. & S.C. Anderson - 1982 "
LOCATE 22, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$
COLOR 11, 0
text$ = "QBASIC by: John De Palma"
LOCATE 24, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$;                                 ' nb: use ";" to keep cursor on the same line
COLOR 14, 7

END SUB

SUB HEADER
SCREEN 0: WIDTH 40: CLS          ' make the screen 40x25
COLOR 15, 1

'       Draw an outline around screen with ASCII characters.
CLS
LOCATE 1, 2, 0, 0, 0                                ' turn off the cursor

    PRINT CHR$(201); STRING$(35, 205); CHR$(187);   ' Draw top border.
    FOR I = 2 TO 23                                 ' Draw left and right borders.
        LOCATE I, 2
        PRINT CHR$(186); SPACE$(35); CHR$(186);
    NEXT I
    LOCATE 23, 2
    PRINT CHR$(200); STRING$(35, 205); CHR$(188);   ' Draw bottom border.

'       Technique for centering text on the screen

COLOR 14, 7

text$ = SPACE$(22)                       ' Set text length
LOCATE 3, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = "   F  R   E L I S E  "     ' Set text length
LOCATE 4, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = SPACE$(22)                       ' Set text length
LOCATE 5, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text

text$ = "         B  Y         "      ' Set text length
LOCATE 6, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = SPACE$(22)                       ' Set text length
LOCATE 7, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = " Ludwig van Beethoven "      ' Set text length use same variable
LOCATE 8, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print new text
text$ = SPACE$(22)                       ' Set text length
LOCATE 9, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = "                  "      ' Set text length
LOCATE 10, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
COLOR 15, 4
text$ = "  Arranged in BASICA by:  "
LOCATE 21, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' nb: use ";" to keep cursor on

text$ = " M.L. & S.C. Anderson - 1982 "
LOCATE 22, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                   ' nb: use ";" to keep cursor on
COLOR 11, 0
text$ = "QBASIC by: John De Palma"
LOCATE 24, (40 \ 2) - LEN(text$) \ 2 + 1   ' Calculate the center
PRINT text$;                               ' nb: use ";" to keep cursor on
COLOR 14, 7

FOR J = 11 TO 20                            '  use the ASCII musical note
    LOCATE J, 10 + J + 1
    COLOR J - 3, 1
    PRINT CHR$(14)
    NEXT J
FOR K = 11 TO 20
    LOCATE K, 30 - K + 1
    COLOR K - 3, 1
    PRINT CHR$(14)
    NEXT K

END SUB

SUB REFRAME
WIDTH 40
LOCATE 5, 8, 0, 0, 0                              ' turn off the cursor, locates top of box
RANDOMIZE TIMER
fgd% = ABS(INT(RND * 14 + 1))                     ' frame color random
COLOR fgd%, 4

    PRINT CHR$(201); STRING$(24, 3); CHR$(187);   ' Draw top border.
    FOR I = 6 TO 15                               ' Draw left and right borders.
        LOCATE I, 8
        PRINT CHR$(3); SPACE$(24); CHR$(3);
    NEXT I
    LOCATE 15, 8
    PRINT CHR$(200); STRING$(24, 3); CHR$(188);   ' Draw bottom border.

'       Technique for centering text on the screen

COLOR 14, 7

LOCATE 6, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text

text$ = "         B  Y         "            ' Set text length
LOCATE 7, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = SPACE$(22)                          ' Set text length
LOCATE 8, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = " Ludwig van Beethoven "            ' Set text length use same variable
LOCATE 9, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print new text
text$ = SPACE$(22)                          ' Set text length
LOCATE 10, (40 \ 2) - LEN(text$) \ 2 + 1    ' Calculate the center
PRINT text$                                 ' Print text
text$ = "    1770  -  1827     "            ' Add Ludwig's stats
LOCATE 11, (40 \ 2) - LEN(text$) \ 2 + 1    ' Calculate the center
PRINT text$                                 ' Print text

END SUB

SUB REFRAME2
WIDTH 40
LOCATE 5, 8, 0, 0, 0                                ' turn off the cursor, locates top of box
RANDOMIZE TIMER
fgd% = ABS(INT(RND * 14 + 1))                       ' frame color random
COLOR fgd%, 4

    PRINT CHR$(201); STRING$(24, 3); CHR$(187);   ' Draw top border.
    FOR I = 6 TO 15                                 ' Draw left and right borders.
        LOCATE I, 8
        PRINT CHR$(3); SPACE$(24); CHR$(3);
    NEXT I
    LOCATE 15, 8
    PRINT CHR$(200); STRING$(24, 3); CHR$(188);   ' Draw bottom border.

'       Technique for centering text on the screen

COLOR 14, 7

LOCATE 6, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text

text$ = "         B E I        "            ' Set text length
LOCATE 7, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = SPACE$(22)                          ' Set text length
LOCATE 8, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = " Ludwig van Beethoven "            ' Set text length use same variable
LOCATE 9, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print new text
text$ = SPACE$(22)                          ' Set text length
LOCATE 10, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text
text$ = "  A  Sonata for Piano "            ' Add Ludwig's stats
LOCATE 11, (40 \ 2) - LEN(text$) \ 2 + 1     ' Calculate the center
PRINT text$                                 ' Print text

END SUB

SUB ROLL
' ***************************   RANDOM.BAS  ********************************
'       For those of us with simple minds, it is exciting to make up
'       formulas to do what we want.  This is a random number generator that
'       displays a character to the screen with random colors and location.
'       I was unable to find this as a formula, or as a technique, so for me
'       this is excitement.  No cracks please....what do you do for fun?!?

RANDOMIZE TIMER                             ' need this to use timer
FOR I% = 1 TO 5
        row% = ABS(INT(RND * 23 + 1))            ' sets the random number of rows
        col% = ABS(INT(RND * 39 + 1))            ' sets the random number of col
        LOCATE row%, col%                   ' locates the set on screen
        fgd% = ABS(INT(RND * 30 + 1))       ' sets random color foreground
        bgd% = ABS(INT(RND * 8 - 1))        ' sets random color background
        COLOR fgd%, bgd%                    ' the ABS term makes the integer +
        PRINT CHR$(14)                      ' prints the music note
        SLEEP 1                             ' waits a second
NEXT I%


END SUB

SUB ROLL2
RANDOMIZE TIMER                             ' need this to use timer
FOR I% = 1 TO 20
        row% = ABS(INT(RND * 23 + 1))            ' sets the random number of rows
        col% = ABS(INT(RND * 39 + 1))            ' sets the random number of col
        LOCATE row%, col%                   ' locates the set on screen
        fgd% = ABS(INT(RND * 30 + 1))       ' sets random color foreground
        bgd% = ABS(INT(RND * 8 - 1))        ' sets random color background
        COLOR fgd%, bgd%                    ' the ABS term makes the integer +
        PRINT CHR$(14)                      ' prints the music note
NEXT I%


END SUB

SUB ROLL3
RANDOMIZE TIMER                             ' need this to use timer
FOR I% = 1 TO 10
        row% = ABS(INT(RND * 23 + 1))            ' sets the random number of rows
        col% = ABS(INT(RND * 39 + 1))            ' sets the random number of col
        LOCATE row%, col%                   ' locates the set on screen
        fgd% = ABS(INT(RND * 30 + 1))       ' sets random color foreground
        bgd% = ABS(INT(RND * 8 - 1))        ' sets random color background
        COLOR fgd%, bgd%                    ' the ABS term makes the integer +
        PRINT CHR$(3)                      ' prints the ASCII 3
        SLEEP 1                             ' waits a second
NEXT I%


END SUB

SUB ROLL4
RANDOMIZE TIMER                             ' need this to use timer
FOR I% = 1 TO 800
        row% = ABS(INT(RND * 23 + 1))            ' sets the random number of rows
        col% = ABS(INT(RND * 39 + 1))            ' sets the random number of col
        LOCATE row%, col%                   ' locates the set on screen
        fgd% = ABS(INT(RND * 30 + 1))       ' sets random color foreground
        bgd% = ABS(INT(RND * 8 - 1))        ' sets random color background
        COLOR fgd%, bgd%                    ' the ABS term makes the integer +
        PRINT CHR$(3)                      ' prints the ASCII 3
NEXT I%


END SUB

SUB ROLL5
RANDOMIZE TIMER                             ' need this to use timer
FOR I% = 1 TO 80
        row% = ABS(INT(RND * 23 + 1))            ' sets the random number of rows
        col% = ABS(INT(RND * 39 + 1))            ' sets the random number of col
        LOCATE row%, col%                   ' locates the set on screen
        fgd% = ABS(INT(RND * 30 + 1))       ' sets random color foreground
        bgd% = ABS(INT(RND * 8 - 1))        ' sets random color background
        COLOR fgd%, bgd%                    ' the ABS term makes the integer +
        PRINT CHR$(3)                      ' prints the ASCII 3
NEXT I%


END SUB

SUB ROLL6
RANDOMIZE TIMER                             ' need this to use timer
FOR I% = 1 TO 50
        row% = ABS(INT(RND * 23 + 1))            ' sets the random number of rows
        col% = ABS(INT(RND * 39 + 1))            ' sets the random number of col
        LOCATE row%, col%                   ' locates the set on screen
        fgd% = ABS(INT(RND * 30 + 1))       ' sets random color foreground
        bgd% = ABS(INT(RND * 8 - 1))        ' sets random color background
        COLOR fgd%, bgd%                    ' the ABS term makes the integer +
        PRINT CHR$(3)                      ' prints the ASCII 3
NEXT I%

END SUB

