'NameIndex Generator - QB4: George A. Jones, Route 3, Box 312
'Louisville, TN 3777-9419 - (615) 982 -2009
DECLARE SUB ASort ()
DECLARE SUB Bottom (Text$)
DECLARE SUB Center (Down%, Text$)
DECLARE SUB EditScrn ()
DECLARE SUB FileSelectScrn ()
DECLARE SUB Frame (Row%, LRow%, Col%, Box%)
DECLARE SUB HelpFile ()
DECLARE SUB InputScrn ()
DECLARE SUB Logon ()
DECLARE SUB MenuScrn ()
DECLARE SUB PrintScrn ()
DECLARE SUB QSearch (Search$, CaseSen%, RecFind%)
DECLARE SUB Spot (Down%, Over%)
DECLARE SUB Upper (Text$)
DECLARE SUB WrongFileScrn ()
COMMON SHARED x%, rn%, TotRec%, RecLen%, File$
Logon
ON ERROR GOTO ErrorProc
ON KEY(10) GOSUB EndProgram
KEY(10) ON
TYPE IndexRecord
   NField AS STRING * 28
   Page AS STRING * 3
   CarrRetn  AS STRING * 2
END TYPE
DIM SHARED Easy AS IndexRecord

File$ = "index.dat"
Header$ = "FANNIN COUNTY 1910 CENSUS INDEX"
SubHead$ = "<INDEX TO SURNAMES, HEADS OF HOUSEHOLDS>"
Page$ = "1910-Index-"

Menu:
CLOSE
DO WHILE A$ <> "X"
MenuScrn
DO
A$ = UCASE$(INPUT$(1))
   SELECT CASE A$
      CASE IS = "C"
         GOSUB CreateFile
      CASE IS = "F"
         GOSUB SelectFile
      CASE IS = "H"
         HelpFile
      CASE IS = "L"
         GOSUB SetScreen
      CASE IS = "P"
         GOSUB PrintIndex
      CASE IS = "X"
         SYSTEM
      CASE ELSE
   END SELECT
LOOP WHILE INSTR("CFHLPX", A$) = 0
LOOP

CreateFile:
IF File$ = "indexsrt.dat" THEN GOSUB WrongFile
GOSUB OpenFile
rn% = TotRec% + 1
Cnt% = 1
InputScrn
x% = 11
DO WHILE Easy.NField <> ""
LOCATE x%, 50: COLOR 15, 0: PRINT rn%: COLOR 1, 3
LOCATE x%, 8: LINE INPUT Easy.NField
   IF Easy.NField = STRING$(28, " ") THEN
      rn% = rn% - 3
      GOSUB OpenFile
      GOSUB ListNames
   END IF
LOCATE x%, 36: LINE INPUT Easy.Page
Easy.CarrRetn = CHR$(13) + CHR$(10)
PUT #1, rn%, Easy
   IF Cnt% >= 4 THEN
      Cnt% = 0
      InputScrn
      x% = 9
   END IF
Cnt% = Cnt% + 1: rn% = rn% + 1: x% = x% + 2:
LOOP

SetScreen:
COLOR 1, 1, 8: CLS : Upper " VIEWING THE FILE  " + File$ + CHR$(32)
Frame 8, 16, 5, 2
IF File$ = "index.dat" THEN
   Status$ = "  U N S O R T E D  "
ELSE
   Status$ = "  S O R T E D  "
END IF
Center 7, " The Selected file contains " + Status$ + " Names"
GOSUB OpenFile
Center 2, " THE FILE CONTAINS " + STR$(TotRec%) + " RECORDS ͻ"
Center 2, "START DISPLAY AT RECORD NUMBER ": INPUT rn%
IF rn% > TotRec% THEN rn% = TotRec%

ListNames:
COLOR 1, 3, 1: CLS : Bottom "VIEWING THE FILE"
Cnt% = 1
IF rn% <= 0 THEN rn% = 1
LOCATE 1, 1
FOR rn% = rn% TO TotRec%
COLOR 0, 3: PRINT TAB(55); : COLOR 15, 0: PRINT rn%: COLOR 0, 3
GET #1, rn%, Easy
PRINT TAB(25); : COLOR 0, 7: PRINT Easy.NField; Easy.Page
   IF Cnt% = 10 THEN
      Cnt% = 1
      rn% = rn% + 1
      EXIT FOR
   END IF
Cnt% = Cnt% + 1
NEXT

x% = 22: COLOR 0, 2
Center 1, "LISTEDITSEARCHSORT,ORMENU  L / E / S/ * / M͹"
   IF rn% >= TotRec% + 1 THEN
      COLOR 14, 1: Center 2, "{{ LAST ITEM - PRESS  M   }}": COLOR 1, 7
   END IF
DO
A$ = UCASE$(INPUT$(1))
SELECT CASE A$
   CASE IS = "L"
      GOSUB ListNames
   CASE IS = "E"
      GOSUB Editor
   CASE IS = "*"
      CLOSE : ASort
   CASE IS = "M"
        RETURN Menu
   CASE IS = "S"
        GOSUB TextSearch
   CASE ELSE
END SELECT
LOOP WHILE INSTR("LES*M", A$) = 0
RETURN Menu

Editor:
IF File$ = "indexsrt.dat" THEN GOSUB WrongFile
x% = 22: COLOR 1, 7
Center 1, "    PLEASE ENTER NUMBER OF THE LINE YOU WISH TO EDIT    "
LOCATE x%, 70: COLOR 0, 3: INPUT rn%
IF rn% <= 0 OR rn% > TotRec% THEN rn% = TotRec%
GET #1, rn%, Easy
EditScrn
Delete$ = Easy.NField
COLOR 1, 7: LOCATE 16, 18: LINE INPUT Name$
   IF Name$ = "ZZZ" OR Name$ = "zzz" THEN
      Easy.NField = "zzz{del}" + LEFT$(Delete$, 18)
      PUT #1, rn%, Easy
      RETURN ListNames
   END IF
   IF LEN(Name$) <> 0 THEN Easy.NField = Name$
LOCATE 16, 18: PRINT Easy.NField
LOCATE 16, 50: LINE INPUT NuPge$: IF LEN(NuPge$) <> 0 THEN Easy.Page = NuPge$
PUT #1, rn%, Easy
RETURN ListNames

TextSearch:
IF File$ = "indexsrt.dat" THEN GOSUB WrongFile
COLOR 1, 3, 1: CLS : Bottom " YOU ARE IN SEARCH MODE "
CaseSen% = 1
DO WHILE RecFind% < 2
   LOCATE 24, 50: COLOR 0, 3: PRINT "  ] or Press <enter> to Quit";
   LOCATE 24, 2: LINE INPUT "Enter Text to Find  [ "; Search$
   RecFind% = 0
   IF Search$ = "" THEN RETURN Menu
   CALL QSearch(Search$, CaseSen%, RecFind%)
   LOCATE 19, 1: COLOR 0, 3: PRINT SPACE$(480)
   IF RecFind% = 0 THEN
      LOCATE 21, 25: PRINT CHR$(34); Search$; CHR$(34); " not found.";
   ELSE
      LOCATE 21, 22: PRINT "The Last Occurrence of Tex%t Found at Line ";
      COLOR 15, 1: PRINT rn%;
   END IF
LOOP

PrintIndex:
GOSUB OpenFile
PrintScrn
LOCATE 15, 38: INPUT rn%: LOCATE 15, 62: INPUT LastNum%
   IF LastNum% > TotRec% THEN LastNum% = TotRec%
COLOR 15, 4: Center 2, "  You Cancel Printing Now by Pressing <M>  "
COLOR 0, 3: Center 2, "Do You Want a Heading ? <Y>es  <N>o  <M>enu"
DO
A$ = UCASE$(INPUT$(1))
SELECT CASE A$
   CASE IS = "Y"
      GOSUB PrinterSetUp
      LPRINT CHR$(27); CHR$(87); CHR$(1): ' double
      LPRINT CHR$(14); TAB(2); Header$;
      LPRINT CHR$(27); CHR$(87); CHR$(0): ' Canc double
      LPRINT TAB(15); SubHead$
      LPRINT
      LineFeed = 1
      pg = 1: EXIT DO
   CASE IS = "N"
      x% = 16: COLOR 0, 7
      Center 1, SPACE$(2) + "PLEASE INDICATE STARTING PAGE NUMBER FOR YOUR PRINT-OUT"
      COLOR 1, 7
      Center 2, SPACE$(22) + "STARTING PAGE NUMBER IS:": INPUT pg
      LPRINT
      GOSUB PrinterSetUp
      EXIT DO
   CASE IS = "M"
      RETURN Menu
   CASE ELSE
END SELECT
LOOP WHILE INSTR("YNM", A$) = 0
IF rn% <= 0 THEN rn% = 1
DO WHILE rn% < LastNum% + 1
LineCnt% = 54
   FOR rn% = rn% TO rn% + 54
      IF INKEY$ = CHR$(27) THEN EXIT DO
   LineCnt% = LineCnt% - 1
   IF rn% > LastNum% THEN EXIT DO
   GET #1, rn%, Easy
   n1$ = Easy.NField + Easy.Page: n2$ = ""
   IF rn% + 55 <= LastNum% THEN
      GET #1, rn% + 55, Easy
      n2$ = Easy.NField + Easy.Page
   END IF
   PRINT TAB(8); n1$; TAB(44); n2$: LPRINT n1$; TAB(38); n2$
   NEXT rn%
rn% = rn% + 55
GOSUB PageNumber: pg = pg + 1
LOOP
IF LineCnt% > 1 THEN
   DO
      LPRINT
      LineCnt% = LineCnt% - 1
   LOOP UNTIL LineCnt% < 1
END IF
CLOSE
GOSUB PageNumber
RETURN Menu

PageNumber:
LPRINT CHR$(13)
LPRINT CHR$(27); CHR$(71);
LPRINT CHR$(27); CHR$(83); CHR$(1);
LPRINT TAB(55); Page$; pg
PRINT TAB(25); pg; " Pages sent to Printer"
LPRINT CHR$(27); CHR$(72);
LPRINT CHR$(27); CHR$(84);
LPRINT CHR$(12)
IF LineFeed = 1 THEN
   LPRINT CHR$(13)
   LineFeed = 0
END IF
RETURN

PrinterSetUp:
LPRINT CHR$(27); CHR$(88); CHR$(8); CHR$(80); : ' Margin
LPRINT CHR$(27); CHR$(73); CHR$(2); : ' LQ
Bottom "Press <Esc> to Abandon Printing"
RETURN

'========U T I L I T I E S========
PageAdvan:
LOCATE 25, 1: COLOR 0, 4: PRINT STRING$(80, 176);
LOCATE 25, 10: COLOR 15, 1: PRINT " Press <Esc> for MENU ";
LOCATE 25, 45: COLOR 0, 2: PRINT " Press <enter> to Continue ";
DO WHILE K$ <> CHR$(251)
K$ = INKEY$
IF K$ = CHR$(13) THEN RETURN
IF K$ = CHR$(27) THEN RETURN Menu
LOOP

OpenFile:
CLOSE : OPEN File$ FOR RANDOM AS #1 LEN = LEN(Easy)
RecLen% = LEN(Easy)
TotRec% = LOF(1) \ LEN(Easy)
RETURN

SelectFile:
FileSelectScrn
DO
A$ = UCASE$(INPUT$(1))
SELECT CASE A$
   CASE IS = "S"
        File$ = "indexsrt.dat"
   CASE IS = "U"
        File$ = "index.dat"
   CASE ELSE
END SELECT
LOOP WHILE INSTR("SU", A$) = 0
RETURN Menu

WrongFile:
WrongFileScrn
GOSUB PageAdvan
RETURN Menu

ErrorProc:
COLOR 0, 3, 4: CLS : Frame 3, 16, 8, 3
x% = 4
SELECT CASE ERR
   CASE 5, 13
      Spot 2, 18: PRINT "* * * P R O G R A M M I N G   E R R O R * * *"
      Spot 2, 18: PRINT "Illegal Function Call or Type Mismatch"
   CASE 25, 68, 71
      Spot 2, 18: PRINT "* * * D E V I C E    E R R O R * * *"
      Spot 2, 18: PRINT "PRINTER or DISK DRIVE not ready or Not Available"
   CASE 63, 64
      Spot 2, 18: PRINT "* * *F I L E  or  R E C O R D   E R R O R * * *"
      Spot 2, 18: PRINT "Bad Record Number, OR Bad File Name"
   CASE ELSE:
END SELECT
Spot 2, 18: PRINT "* * ERROR NUMBER * * ͯ ";
COLOR 15, 1: PRINT ERR: COLOR 0, 3
Spot 2, 18: LINE INPUT "Press <ENTER> To Return to MENU....."; anyk$
RESUME Menu

EndProgram:
   SYSTEM

SUB ASort
COLOR 0, 3, 1: CLS :  Frame 3, 6, 2, 2
Center 2, "  S O R T I N G    P L E A S E   W A I T"
LOCATE 7, 1: BeginTime = TIMER
SHELL "SORTFILE index.dat indexsrt.dat/+0,25"
   ElapseTime = TIMER: BEEP: BEEP: BEEP
   Results = (ElapseTime - BeginTime) / 60
LOCATE 20, 10: COLOR 1, 7
   PRINT "TIME REQUIRED TO SORT WAS ";
   PRINT USING "##.##"; Results; : PRINT "  Minutes"
LOCATE 22, 10: LINE INPUT "Press <ENTER> to continue..."; anyk$
END SUB

SUB Bottom (Text$)
LOCATE 25, 1: COLOR 14, 5: PRINT STRING$(80, 240);
Text$ = " " + Text$ + " "
p% = INT(82 - LEN(Text$)) / 2
LOCATE 25, p%: COLOR 15, 2: PRINT Text$;
END SUB

SUB Center (Down%, Text$)
x% = x% + Down%
p% = INT((82 - LEN(Text$)) / 2)
LOCATE x%, p%: PRINT Text$;
END SUB

SUB EditScrn
COLOR 0, 1, 8: CLS : Upper "T H E   E D I T   S C R E E N": Frame 4, 17, 4, 3
Center 2, "To accept NAME, or PAGE, as written, Press <enter>"
Center 2, "To CORRECT either NAME  or PAGE , re-type entry and Press <enter>"
Center 2, "To DELETE this record - Type " + CHR$(34) + "ZZZ" + CHR$(34) + " and Press <enter>"
Spot 2, 17: COLOR 15, 4: PRINT " E d i t i n g   R e c o r d   N u m b e r"
LOCATE x%, 62: COLOR 15, 0: PRINT rn%
Spot 2, 18: COLOR 0, 2: PRINT "N A M E ": LOCATE x%, 50: PRINT "P A G E"
Spot 2, 18: COLOR 0, 7: PRINT Easy.NField; : LOCATE x%, 50: PRINT Easy.Page
END SUB

SUB FileSelectScrn
COLOR 0, 1, 8: CLS : Upper "FILE SELECTION MENU": Frame 4, 10, 4, 3
Center 3, "Select <U>nsorted File for Searches, Editing, and Additions"
Center 1, "Select <S>orted File for Print of Final Index"
COLOR 0, 7: Center 2, "  Choose <S> or <U>  See Helpful Hints Below  "
Frame 14, 22, 4, 2
Spot 13, 8
PRINT "<U>nsorted file is source data; therefore all additions, edits, etc,"
Spot 1, 8
PRINT "must be made while using that file.  The <S>orted file is recreated"
Spot 1, 8
PRINT "each time you use sort and any changes to <S>orted file would be"
Spot 1, 8
PRINT "over-written by the Sort."
Spot 2, 8
PRINT "Remember to sort file and select <S>orted file for final print-out"
Spot 1, 8
PRINT "of index."
END SUB

SUB Frame (Row%, LRow%, Col%, Box%)
ss% = INT(80 - (2 * Col%))
SELECT CASE Box%
   CASE 1
      LOCATE Row%, Col%: PRINT CHR$(218); STRING$(ss%, 196); CHR$(191)
      Side% = 179: GOSUB SideLines
      LOCATE Row%, Col%: PRINT CHR$(192); STRING$(ss%, 196); CHR$(217);
   CASE 2
      LOCATE Row%, Col%: PRINT CHR$(201); STRING$(ss%, 205); CHR$(187)
      Side% = 186: GOSUB SideLines
      LOCATE Row%, Col%: PRINT CHR$(200); STRING$(ss%, 205); CHR$(188);
   CASE 3
      LOCATE Row%, Col%: PRINT CHR$(219); STRING$(ss%, 223); CHR$(219)
      Side% = 219: GOSUB SideLines
      LOCATE Row%, Col%: PRINT CHR$(219); STRING$(ss%, 220); CHR$(219);
   CASE 6
      Row% = Row% + 1: LRow% = LRow% + 2: Col% = Col% + 2
      FOR Row% = Row% TO LRow%: LOCATE Row%, Col%
      PRINT STRING$(ss% + 2, 219): NEXT
   CASE ELSE
END SELECT
x% = 3
EXIT SUB

SideLines:
FOR Row% = Row% + 1 TO LRow%: LOCATE Row%, Col%:
PRINT CHR$(Side%); SPACE$(ss%); CHR$(Side%): NEXT
RETURN
END SUB

SUB HelpFile
COLOR 0, 3, 0: CLS : Frame 3, 4, 12, 1
Center 1, "W O R K I N G"
HelpText = FREEFILE
OPEN "index.hlp" FOR BINARY AS HelpText
Size = LOF(HelpText)
Help$ = STRING$(Size, 32)
GET HelpText, , Help$
CLOSE HelpText

DO
m% = 1
   DO
      CLS
      FOR x% = 1 TO 25: LOCATE x%, 1: PRINT MID$(Help$, m%, 80);
         m% = m% + 80
      NEXT
      DO
         K$ = UCASE$(INKEY$)
         IF K$ = CHR$(27) THEN EXIT SUB
         IF K$ = CHR$(13) OR K$ = "T" THEN EXIT DO
      LOOP
      IF K$ = "T" THEN EXIT DO
      IF m% >= Size THEN EXIT SUB
   LOOP
LOOP
END SUB

SUB InputScrn
COLOR 1, 1, 8: CLS : Upper "DATA  ENTRY SCREEN": Frame 3, 18, 2, 3
Spot 2, 8: PRINT "ͯ Type Name - Press <enter>."
Spot 1, 8: PRINT CHR$(186)
Spot 1, 8: PRINT CHR$(186); SPACE$(27); "ͯ Type page number - Press <enter>"
Spot 2, 8: COLOR 0, 2: PRINT "SURNAME, FIRST NAME   "
LOCATE x%, 36: PRINT CHR$(25); "  PAGE "
LOCATE x%, 48: COLOR 11, 0: PRINT "RECORD NUMBER"
COLOR 1, 7: Frame 22, 23, 8, 2
Center 20, " To EXIT - Press <enter> at Next blank SURNAME space": COLOR 7, 4
FOR r% = 11 TO 17 STEP 2
   LOCATE r%, 8: PRINT CHR$(32); STRING$(20, 177)
   LOCATE r%, 36: PRINT CHR$(32); STRING$(2, 177)
NEXT r%
END SUB

SUB Logon
COLOR 1, 0, 8: CLS : Bottom " Copyright  1989 by George A. Jones "
COLOR 7, 0: Frame 6, 16, 11, 6: COLOR 11, 0: Frame 6, 16, 12, 3
p% = 22: COLOR 2, 0
Spot 4, p%: PRINT "ͻ ͻ ͻ ͻ     ͻ"
Spot 1, p%: PRINT "     ͵       ͻ     ͻ"
Spot 1, p%: PRINT "ͼ ͼ     ͼ ͼ ͼ"
p% = 25: COLOR 14, 0
Spot 2, p%: PRINT "͸ ͻ ͻ ͻ    "
Spot 1, p%: PRINT "                 Ȼ ɼ"
Spot 1, p%: PRINT "             ͵     X"
Spot 1, p%: PRINT "                 ɼ Ȼ"
Spot 1, p%: PRINT ";     ͼ ͼ    "
COLOR 11, 0: Center 5, "<<< Press any Key >>>"
SLEEP (6)
END SUB

SUB MenuScrn
COLOR 1, 1, 4: CLS : Bottom "P R O G R A M   S E L E C T I O N"
COLOR 1, 15: Frame 2, 3, 4, 2
x% = 2: Center 1, "FANNIN COUNTY GEORGIA  -  1910 CENSUS INDEX"
COLOR 8: Frame 6, 17, 6, 6: COLOR 14, 3: Frame 6, 17, 6, 3
COLOR 11, 3: Frame 7, 8, 14, 1: COLOR 0, 3: Center 5, "T H E   M E N U"
p% = 8: COLOR 1, 7
Spot 4, p%: PRINT "<C>reate INDEX / add to INDEX  "
LOCATE x%, 48: PRINT "<F>ile Selection Feature "
Spot 2, p%: PRINT "<L>ist, Edit, Search, Sort Data"
LOCATE x%, 48: PRINT "<P>rint Two Column INDEX "
Spot 2, p%: PRINT "<H>elp - How to Create Index   "
LOCATE x%, 48: PRINT "   e<x>it the Program    "
x% = 10: p% = 9: COLOR 15, 4
Spot 2, p%: PRINT "C": LOCATE x%, 49: PRINT "F"
Spot 2, p%: PRINT "L": LOCATE x%, 49: PRINT "P"
Spot 2, p%: PRINT "H": LOCATE x%, 53: PRINT "X"
COLOR 9, 7: Frame 21, 22, 4, 3
COLOR 1, 7: Center 19, "SELECT  C - F - H - L - P - or - X"
END SUB

SUB PrintScrn
COLOR 1, 1, 8: CLS : Upper "Printer Instructions  " + File$
Frame 3, 20, 3, 1: Center 18, " Select Number of Lines/Pages "
IF File$ = "index.dat" THEN
   Status$ = "  U N S O R T E D  "
ELSE
   Status$ = "  S O R T E D  "
END IF
x% = 4:
Center 1, "<< File Selected contains " + Status$ + " Names >>"
COLOR 0, 2: Center 2, "THERE ARE " + STR$(TotRec%) + " RECORDS IN THE FILE"
Spot 2, 6: COLOR 0, 7: PRINT " USING 110 RECORDS TO PAGE "
LOCATE x%, 38: PRINT " RECORD 1 TO 550 IS FIVE PAGES "
Spot 2, 38: PRINT "  551 TO 1100 IS TEN PAGES     "
Spot 2, 38: PRINT " 1101 TO 1650 IS FIFTEEN PAGES "
COLOR 1, 7
Center 2, "START PRINTING AT RECORD [       ]  END AT RECORD [        ]"
END SUB

SUB QSearch (Search$, CaseSen%, RecFind%)
CLOSE : OPEN "index.dat" FOR BINARY AS 1
FileSize! = LOF(1)
Size! = FRE("") / 3
IF Size! > 32000 THEN Size! = 32000
Size! = INT(Size! / RecLen%) * RecLen%
Pass% = FileSize! / Size!
IF FileSize! / Size! > INT(Pass%) THEN Pass% = Pass% + 1
   FOR r% = 1 TO Pass%
      BgnRec% = 1
      Text$ = SPACE$(Size!)
      GET 1, , Text$
      GOSUB SearchRecord
      Text$ = ""
   NEXT
CLOSE 1
EXIT SUB

SearchRecord:
DO
NextRecord = 0
IF CaseSen% = 1 THEN
   Addr% = INSTR(BgnRec%, UCASE$(Text$), UCASE$(Search$))
ELSE
   Addr% = INSTR(BgnRec%, Text$, Search$)
END IF
IF Addr% > 0 THEN
   RecFind% = 1
   Place% = (Addr% \ RecLen%) * RecLen% + 1
   rn% = ((Size! / RecLen%) * r%) - ((Size! - Place%) \ RecLen%)
   Cnt% = Cnt% + 1
   Record$ = MID$(Text$, Place%, RecLen% - 2)
   VIEW PRINT 12 TO 16: LOCATE 16, 80: PRINT : VIEW PRINT
   LOCATE 19, 8: PRINT "Text Found in Record: ";
   COLOR 15, 0: PRINT rn%;
   LOCATE 19, 50: COLOR 15, 1: PRINT Cnt%;
   COLOR 0, 3: PRINT " Record(s) Found ";
   LOCATE 20, 12: PRINT "..ͯ....Press <enter> to continue Search.";
   LOCATE 21, 20: PRINT "....OR....Press <Esc> + <enter> to Stop Searching.";
   Flash$ = MID$(Text$, Addr%, LEN(Search$))
   LocFlash = Addr% - Place% + 1
   LOCATE 18, 2: PRINT Record$;
   COLOR 21, 7: LOCATE 18, LocFlash + 1: PRINT Flash$;
   DO WHILE K$ <> CHR$(251)
   K$ = INKEY$
      COLOR 0, 3
      IF K$ = CHR$(13) THEN
         BgnRec% = Place% + RecLen% - 1
         LOCATE 16, 18: PRINT Record$
         NextRecord = 1
         EXIT DO
      END IF
      IF K$ = CHR$(27) THEN
         LOCATE 18, 2:  PRINT Record$;
         CLOSE 1
         EXIT SUB
      END IF
   LOOP
END IF
LOOP WHILE NextRecord = 1
RETURN
END SUB

SUB Spot (Down%, Over%)
x% = x% + Down%: LOCATE x%, Over%
END SUB

SUB Upper (Text$)
LOCATE 1, 2: COLOR 14, 4: PRINT STRING$(78, 196);
Text$ = " " + Text$ + " "
p% = INT(82 - LEN(Text$)) / 2
LOCATE 1, p%: PRINT Text$;
COLOR 0, 7
END SUB

SUB WrongFileScrn
COLOR 8, 0, 4: CLS : Frame 4, 18, 4, 6: COLOR 1, 7: Frame 4, 18, 4, 3
COLOR 15, 1: Center 3, "  You are trying to use wrong file. "
COLOR 0, 7
Center 3, "You cannot add names to, Search, or Edit <S>orted file."
Center 2, "If You wish to Search, Edit, or Add Names, please return to MENU"
Center 1, "and use <F>ile Selection feature to choose <U>nsorted file."
COLOR 1, 7
Center 4, "<< Please See Helpful Hints at <F>ile Selection Menu >>"
END SUB

