' ͸
'  Author: Mark (Rawhide) Geer - Pink Koyote Productions - Albuquerque
'  Main Program: PB3MDEMO.BAS                                         
'  $INCLUDEs: PB3MSE.Inc                                              
'  $LINKs   : PB3MSE.PBL (Library)                                    
'  Creation Date: 03-05-1993                                          
'  Requirements: Mouse, EGA+                                          
'  Program Description: Demo Of PB3MSE Routines (in EGA)              
' ;

$STRING 1

BOX:
DATA 142,168,190,216,238,264 'Screen location for small boxes. [X only]

%True = -1
%False = NOT %True

' Include Declarations From Pb3Mse.Inc
%Custom = %True      ' Yes, I want to have a custom cursor!
%Accept = %True      ' Demonstrate Mse.Accept
%Page = %True        ' Yes To Demonstrate Mouse Pages [screen]
%Inch = %True        ' Yes To Demonstate Mse.Inches
%Buttinfo = %False   ' Nah
%Move = %False       ' Uh Uh
%Herc = %False       ' Get Outta Here!

DIM MCursor$(1)     ' Allocate How Many User-Defined Mouse Graphics
                    ' We Will Be Using In An $tring Array. Here, 1.

$INCLUDE "d:\mse\BOX.MSE"      ' Load Custom Mouse Cursor [Remember that
                        ' BOX.MSE's MCursor$ array *MUST* have an
                        ' element number [look at BOX.MSE, it's 1]

$INCLUDE "d:\mse\PB3MSE.INC"   ' Bring in PB3MSE DECLARations and $LINK

DIM Boxit%(3,3:4)

RESTORE BOX
FOR A = 1 TO 3       ' Read small box screen coords.
    READ Boxit%(A, 3), Boxit%(A, 4)
NEXT

Inchx% = 6        ' Set Mickeys/Inches Ratio
Inchy% = 6

SCREEN 9          ' 640x350x16 Screen
                  ' Where is SCREEN 13?

For I=0 to 4
LINE (0+I, 0+I)-(639-I, 349-I), 4, B        'Put Large Frame on screen
NEXT

LOCATE 4, 45: PRINT "PB3MSE DEMO"
LOCATE 5, 45: PRINT "Written By: Mark (Rawhide) Geer"

CALL DEMO            ' Start Demo
Mse.Init             ' Reset The Mousey [you want to reset the ratio]
END


SUB DEMO SHARED
Mse.Init             ' Initialize Mouse And Get # Of Buttons

Mse.Cursor 1         ' Choose Graphic Cursor [MCursor$(1) - BOX.MSE]

Mse.Getpage          ' Get Page [screen] where Mouse Resides

LOCATE 3,3:? "Mouse Present? = "STR$(Mse.Ok%,1)
LOCATE 4,3:? "# Of Mouse Buttons ="STR$(Mse.Buttons%,1)
LOCATE 5,3:? "Number Of Defined cursors = "STR$(UBOUND(Mcursor$),1)
LOCATE 6,3:? "Present Cursor # = ";STR$(Mse.Curnum%,1)
LOCATE 7,3:? "Current Mouse Page = "STR$(Mse.Page%,1)

LINE (130, 229)-(526, 335), 11, B     ' Put a box where mouse will
LINE (131, 230)-(525, 334), 9, Bf     ' will roam.

FOR I = 1 TO 3                        ' Place three small boxes
	 LINE (Boxit%(I, 3) - 1, 233)-(Boxit%(I, 4) + 1, 257), 0, B
	 LINE (Boxit%(I, 3) + 3, 236)-(Boxit%(I, 4) + 4, 260), 0, Bf
	 LINE (Boxit%(I, 3), 234)-(Boxit%(I, 4), 256), 14, Bf
	 LOCATE 18,14+(I*6):?LTRIM$(STR$(I,1))
NEXT I

Mse.Window 230, 334, 131, 525, 0    ' Limit mouse to blue box
Mse.On
Mse.Hotspot           ' Locate Mouse's Hotspots
Mse.Inches Inchy%, Inchx%
LOCATE 6,3,0:? "Mouse HotSpots (x,y) = "STR$(Mse.Hotx%,2)","STR$(Mse.Hoty%,2)
LOCATE 8,45:? "Push any of the"STR$(Mse.Buttons%,1)" Buttons"
LOCATE 11,3:? "Mickeys/Inch Ratio (x,y) = "STR$(Inchx%,2)","STR$(Inchy%,2)
LOCATE 10, 45: PRINT "Also, select any small box."
LOCATE 12, 45: PRINT "Keep clicking while slowly"
LOCATE 13, 45: PRINT "approaching a box"
WHILE NOT INSTAT
	 Mse.Status       ' Get current status of mouse
	 LOCATE 13, 3: PRINT USING "Row = ##  Col = ##"; Mse.Row%, Mse.Col%
    LOCATE 14, 3: PRINT USING "YPos = ###   XPos = ###"; Mse.Y%, Mse.X%
	 IF Toggle% AND Mse.Buttpress% = %false then
	 LOCATE 16, 19: PRINT SPACE$(40)       ' Blanking Toggle
	 Toggle%=%false
	 END IF
	 IF ISTRUE(Mse.Buttpress%) THEN
		 Toggle%=%true
		 SELECT CASE Mse.Buttpress%   ' Is There A Mouse Button Pressed?
              CASE 1
                   LOCATE 16, 19: PRINT "Left"
              CASE 4
                   LOCATE 16, 24: PRINT "Middle"
              CASE 2
                   LOCATE 16, 30: PRINT "Right"
       END SELECT
		 FOR I = 1 TO 3  ' Check if mouse is in any of the three boxes.
				  IF Mse.Accept(234, 256, Boxit%(I, 3), Boxit%(I, 4)) THEN
						LOCATE 16,45:? "Box"STR$(I,1)" Selected"
				  END IF
		 NEXT
     	 END IF
WEND

END SUB
' EOP: PB3MDEMO
