          SCRNIO.PBU
             Attr        - Calculates a single integer from forground and
                           background
             Back        - Calculates background color from a single
                           integer
             CapsOff     - Toggles Caps Lock key off
             CapsOn      - Toggles Caps Lock key on
             CapStat     - Returns status of Caps Lock key
             CheckKey    - Returns true if key in keyboard buffer
             ClrKBD      - Clears keyboard buffer without removing keys
             CurDisplay  - Returns active display adapter
             CurBot      - Bottom scanline of cursor
             CurTop      - Top scanline of cursor
             Fill        - Fills a box on the screen with a charactor
             Fore        - Calculates forground color from an integer
             GetKey      - Get a single key from KB buffer, wait if no key
                           present
             GetScrn     - Places any portion of the screen into a string
             InsertOff   - Toggles insert status off
             InsertOn    - Toggles insert status on
             InsStat     - Returns status of INS key
             IsAlt       - Returns true if ALT key is depressed
             IsCaps      - Returns true if Caps Lock key is depressed
             IsCtrl      - Returns true if Ctrl key is depressed
             IsInsert    - Returns true if INS key is depressed
             IsLShift    - Returns true if Left Shift key is depressed
             IsMouse     - Returns number of buttons on mouse if installed
             IsNumLock   - Returns true if Num Lock key is depressed
             IsRShift    - Returns true if Right Shift key is depressed
             IsScroll    - Returns true is Scroll Lock key is depressed
             LScroll     - Scroll any portion of the screen to the left
             MaskIn      - Get masked input from user
             MouseKey    - Gets a key from KB, mouse movement detected
             MLocate     - Locate the mouse cursor at any place on screen
             MouseOff    - Turns mouse cursor off
             MouseOn     - Turns mouse cursor on
             MouseStat   - Returns mouse position, and button pressed
             MouseWin    - Define the window for mouse cursor
             NumIn       - Get numeric input from user
             NumOff      - Toggles Num Lock key off
             NumOn       - Toggles Num Lock Key on
             NumStat     - Returns status of Num Lock Key
             PutScrn     - Puts a string created with GetScrn back onto
                           the screen
             ReAttr      - Changes the color of any position on the screen
             ReColor     - Changes all designated attribute bytes to new color
             RScroll     - Scroll any portion of the screen to the right
             ScrollDN    - Scrolls any part of the screen down
             ScrollOff   - Toggles Scroll Lock key off
             ScrollOn    - Toggles Scroll Lock key on
             ScrollStat  - Returns the status of the scroll-lock key
             ScrollUP    - Scrolls any part of the screen up
             SetText     - Sets cursor color from single integer
             StuffKey    - Stuff the KB buffer with up to 16 chars
             TextEd      - Lets user edit the chars within a line
             TextIn      - Gets ASCII input from user with editing options
             VidAddr     - Returns the segment of the video address
             VidMode     - Returns current video mode

          TOOL.PBU
             Bin2Dec     - Converts a binary string to a decimal integer
             BitSet      - Returns true if a specified bit is on
             Center      - Centers a string with spaces padded to left and
                           right
             Compress    - Compress a text string at about 3:2 ratio
             Cpu         - Identifies CPU that program is running on
             Date2Int    - Converts a date to a 2 byte integer
             Decrypt     - Decrypt a string using a password
             DelChar     - Delete a charactor within a string at desired
                           location
             DesqView    - Returns true if DesqView/TaskView is active
             Encrypt     - Encrypt a string with a password
             Evaluate    - Evaluate a given expression and return answer
             GetAddr     - Returns segment and offset of a string
             Hex2Dec     - Converts a hexadecimal string to a decimal
                           integer
             InsChar     - Insert a charactor within a string at desired
                           location
             Int2Date    - Converts a 2 byte integer to a valid date
             IsAlpha     - Returns true if a char is alpha
             IsAlphaNum  - Returns true is a char is alpha or numeric
             IsASCII     - Returns true if a char is printable ASCII
             IsNum       - Returns true if a char is numeric
             IsPunc      - Returns true if a char is punctuation
             LPad        - Pad a string to the left with desired char
             LRotate     - Rotates a string to the left one charactor
             MakeInt     - Converts two bytes into an integer
             NumParsCmds - Returns the number of parameters found on the
                           command line
             ParseCmds   - Does the actual parsing of the command line into
                           a specified array
             ResetBit    - Turns a specified bit off within an integer
             Reverse     - Reverses all charactors in a string
             RInstr      - Like INSTR, only searches in reverse
             RPad        - Pad a string to the right with desired char
             RRotate     - Rotates a string to the right one charactor
             SetBit      - Turns a specified bit on within an integer
             ShiftAlpha  - Shifts uppercase alpha chars over chars
             ToggleBit   - Toggles a specified bit on or off
             Trim        - Trims spaces from both ends of a string
             UnCompress  - Uncompresses a compressed string

          WINDO.PBU
             AddShadow   - Adds a shadow to current window
             Box         - Draws a box on the screen
             ChangeWin   - Changes the size of the current window
             ClearWin    - Clears the contents of the current window
             CloseWin    - Closes a previously opened window
             GetFrst     - Return the first uppercase letter or number in
                           a string
             InitPBScreen- Initialize all variables for window routines
             Menu        - Displays a menu and returns choice from user
             MoveWin     - Moves the current window in any one of 4
                           directions
             NoShadow    - Removes the shadow form the current window
             OpenWin     - Pops a window on the screen saving whatever is
                           underneath
             PFirst      - Print a string on the screen with the first
                           uppercase letter or number highlighted
             ScrollPrint - Scrolls all the lines in a window up one, and
                           prints a string on the bottom line
             ScrollWin   - Scrolls the text within the current window in
                           one of 4 directions
             Title       - Displays a title in one of 6 positions
             WinColor    - Changes the text color of the current window
             WPrint      - Displays a string within the current window
             WPrintC     - Centers a text string horizontally within
                           current window
             ZoomBox     - Explodes a box on the screen

          DOSIO.PBU
             Atrb        - Turns DOS attribute into a printable string
             Attrb       - Turns printable string into a DOS attribute
             CurDrive    - Returns the current logged drive
             DIR2        - Returns the filename, filesize, and date of a spec
             DirCnt      - Counts the number of subdirectories within a
                           directory
             DrvSpace    - Double precision integer containing drive space
                           left
             Exist       - Returns true if file exists
             Expand      - Expands a file to it's full 12 charactors
             FileCount   - Returns the number of files in dir matching
                           specification
             FileDate    - Converts a DOS integer into a valid date
             GetDir      - Returns an array containing all filenames
                           matching spec
             GetDirs     - Returns an array containing all subdirectories
                           within a directory
             GetDosV     - Returns current DOS version number
             GetDrive    - Returns current active drive/partition
             GetRec      - Retrieves a record from a file
             NumRecs     - Returns total number of records within a file
             PutRec      - Put a record into a file
             RecSearch   - Performs a search of a random access file for
                           records based on a boolean pattern
             SetDrive    - Like CHDRIVE, but does not cause an error if
                           drive is invalid
             SizeDir     - Returns the total number of bytes within a
                           directory
             SortDirExt  - Sorts a directory array by extension then name
             VLabel      - Returns the volume label for default drive

          EMSIO.PBU
             CloseHandle - Closes a previously allocated EMS Handle
             EMSFree     - Returns the amount of free EMS memory
             EMSHandle   - Allocates the requested pages and returns
                           handle number
             EMSInst     - Returns the amount of EMS installed
             EMSStat     - Returns the status of installed EMS
             EMSVer      - Returns the version number of the EMS driver
             FindHand    - Returns the file handle number for given name
             FreePages   - Returns the number of free pages in EMS
             GetHandName - Returns 8 charactor name of an EMS handle
             Handles     - Returns the number of handles used
             IsEMS       - Returns true if EMS installed
             MapPage     - Maps logical page to Page Frame
             PageFrame   - Returns the address segment of the page frame
             SetHandName - Assign an 8 charactor name of an EMS handle
             UnMapPage   - Unmaps current mapped logical frame

