'***** QBTREE ver 5.50 declarations *****
'standard functions
DECLARE FUNCTION InitQBTREE% (MKF%, MDF%)
DECLARE FUNCTION ExitQBTREE% ()
DECLARE FUNCTION QBTreeVer% (ver%)
DECLARE FUNCTION CreateDataFile% (filename$, recl%)
DECLARE FUNCTION CreateKeyFile% (filename$, keyl%)
DECLARE FUNCTION ExpandKeyFile% (kfileno%, nokeys&)
DECLARE FUNCTION ExpandDataFile% (dfileno%, norecs&)
DECLARE FUNCTION FreeKeyFile% ()
DECLARE FUNCTION FreeDataFile% ()
DECLARE FUNCTION OpenDataFile% (filename$, dfileno%, asmode%)
DECLARE FUNCTION OpenKeyFile% (filename$, kfileno%, asmode%)
DECLARE FUNCTION AddKeyRecord% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION AddKey% (kfile%, dfile%, Qkey2$)
DECLARE FUNCTION UpdateRecord% (dfile%, Qrec2$)
DECLARE FUNCTION GetFirst% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION GetLast% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION GetPrev% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION GetEqual% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION GetNext% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION GetLT% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION GetLTE% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION GetGTE% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION GetGT% (kfile%, dfile%, Qkey2$, Qrec2$)
DECLARE FUNCTION StoreKey% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveFirst% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveLast% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrievePrev% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveEqual% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveNext% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveLT% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveLTE% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveGTE% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveGT% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION GetPosition% (kfileno%, recno&)
DECLARE FUNCTION GetDirect% (dfileno%, drecno&, Qrec2$)
DECLARE FUNCTION DeleteKey% (kfile%, Qkey2$)
DECLARE FUNCTION DeleteKeyRecord% (kfile%, dfile%, Qkey2$)
DECLARE FUNCTION StatKeyFile% (kfileno%, keyl%, keys&, bfileno%)
DECLARE FUNCTION StatDataFile% (dfileno%, recl%, recs&, bfileno%)
DECLARE FUNCTION FlushKeyFile% (kfileno%, dup%)
DECLARE FUNCTION FlushDataFile% (dfileno%, dup%)
DECLARE FUNCTION CloseKeyFile% (kfileno%)
DECLARE FUNCTION CloseDataFile% (dfileno%)
'---- INTERNAL UTIL ----
DECLARE SUB MemCopy (BYVAL FromSeg%, BYVAL FromOff%, BYVAL ToSeg%, BYVAL ToOff%, BYVAL count%)
DECLARE SUB GetDiskInfo (drive$, AvailClusters%, MaxClusters%, BytesSector%, SectorsCluster%, freebytes&)
DECLARE FUNCTION GetDefaultDrive% ()
DECLARE FUNCTION FileExists% (filename$)
DECLARE FUNCTION GetDosVersion% ()
DECLARE FUNCTION SFTFiles% ()
DECLARE FUNCTION GetXEInfo% (class%, action%, locus%)
'---- EXTERNAL UTIL -----
DECLARE FUNCTION CreateFile% (pathname$, BYVAL attribute%)
DECLARE FUNCTION OpenDevice% (pathname$, BYVAL mode%, handle%, flen&)
DECLARE FUNCTION ReadDevice% (BYVAL handle%, BYVAL start&, BYVAL bytes&, BYVAL vseg%, BYVAL voff%)
DECLARE FUNCTION WriteDevice% (BYVAL handle%, BYVAL start&, BYVAL bytes&, BYVAL vseg%, BYVAL voff%)
DECLARE FUNCTION CloseDevice% (BYVAL handle%)
DECLARE FUNCTION DeleteFile% (pathname$)
DECLARE FUNCTION RenameFile% (oldpathname$,newpathname$)
'network functions, record-locking level
DECLARE FUNCTION LoadDataHeader% (dfileno%)
DECLARE FUNCTION LoadKeyHeader% (kfileno%)
DECLARE FUNCTION LockDataHeader% (dfileno%)
DECLARE FUNCTION LockKeyFile% (kfileno%)
DECLARE FUNCTION LockRecord% (dfileno%, recno&)
DECLARE FUNCTION UnlockDataHeader% (dfileno%)
DECLARE FUNCTION UnlockKeyFile% (kfileno%)
DECLARE FUNCTION UnlockRecord% (dfileno%, recno&)
DECLARE FUNCTION LockBytes% (handle%, mode%, sbyte&, bytes&)

