' SpoolIt.BAS
' Example program to demonstrate the PRINT spooler interface

' $INCLUDE: 'QB.BI'

' Define the data structure we need for spooling files

TYPE SpoolRec
   priority AS STRING * 1
   nameOff  AS INTEGER
   nameSeg  AS INTEGER
END TYPE

' Declare the variables needed for spooling

DIM SpoolFile AS STRING * 64
DIM aSpoolRec AS SpoolRec
DIM Regs AS RegType


' Check to see if the PRINT.COM spooler is loaded

Regs.AX = &H100		' spooler load residency request
Interrupt &H2F, Regs, Regs
AL = Regs.AX MOD 256
IF AL = 0 THEN
  PRINT "PRINT is not loaded."
  END
END IF

' Ask the user for the name of a file to spool

LINE INPUT "Enter the filename to print >", Spool$
IF LEN(Spool$) = 0 THEN END   ' nothing to do, so exit

SpoolFile = Spool$ + CHR$(0)  ' create an ASCIIZ string

' Fill in the fields in the spool data record
aSpoolRec.priority = CHR$(0)
aSpoolRec.nameOff = VARPTR(SpoolFile)
aSpoolRec.nameSeg = VARSEG(SpoolFile)

' Send the file on its way
Regs.AX = &H101
Regs.dx = VARPTR(aSpoolRec)
Interrupt &H2F, Regs, Regs

' Isolate the status of the spool operation
SpooledOK% = NOT Regs.flags AND 1
IF SpooledOK% THEN
  PRINT "Your file has been placed in the queue."
ELSE
  AL = Regs.AX MOD 256
  PRINT "Could not spool your file, error code is "; AL
END IF
END
