' Program SysInfo.Bas
' Program to obtain the PC system ID byte
' and the ROM BIOS date
'

CONST SysIDSeg = &HF000
CONST SysIDOff = &HFFFE
CONST RDOffset = &HFFF5

DIM RomDate AS STRING

DEF SEG = SysIDSeg
SysID% = PEEK(SysIDOff)
RomDate = ""
FOR I% = 0 TO 7
   RomDate = RomDate _
           + CHR$(PEEK(RDOffset + I%))
NEXT I%

PRINT "The system ID number is ";
PRINT HEX$(SysID%); " which is a ";

SELECT CASE SysID%
      CASE &HFF
          PRINT "PC"
      CASE &HFE, &HFB
          PRINT "PC/XT"
      CASE &HFD
          PRINT "PC Jr."
      CASE &HFC
          PRINT "PC/AT or PC/XT-286"
      CASE &HF9
          PRINT "PC Convertible"
      CASE ELSE
          PRINT "unlisted PC model"
END SELECT

PRINT "The ROM BIOS release date is ";
PRINT RomDate
END
