' TimrDemo.BAS
' Demonstration of on-screen clock using TIMER
DEFINT A-Z
CLS
' Since clock is initially un-hidden, we should 
' display it manually the first time (rather
' than wait for the first timer event).
GOSUB TimerDisplay
' update frequency is 1 second
ON TIMER(1) GOSUB TimerDisplay
TIMER ON
' Display a silly pattern until a key is pressed
J = 1
DO
 FOR I = 10 TO 20
   ' delay a while...
   FOR A = 1 TO 5000: NEXT A
   X$ = STRING$(60, "*")
   MID$(X$, J, 1) = " "
   LOCATE I, 1: PRINT X$;
   J = ((J + 1) MOD 59) + 1
 NEXT I
LOOP WHILE INKEY$ = ""
END
' This is the TIMER event handler
TimerDisplay:
  OldRow = CSRLIN       ' save current screen row
  OldCol = POS(0)       ' save current screen column
  LOCATE 1, 70          ' move cursor to clock loc
  PRINT TIME$;          ' display the time
  LOCATE OldRow, OldCol ' restore cursor to saved loc
  RETURN
