@echo off

if "%1" == "" goto usage
if "%2" == "" goto usage

IF "%2" == "3.5"   goto TypeOK
IF "%2" == "5.25"  goto TypeOK

echo ***
echo *** ERROR: %2 is not a valid disk type.  ***
echo ***
goto usage

:TypeOk

ECHO ****************************************************************
echo *                                                              *
echo * !!!!! WARNING WARNING WARNING WARNING WARNING WARNING  !!!!! *
echo *  SINCE THIS BATCH FILE PERFORMS MINIMAL ERROR CHECKING,      *
echo ***                    PLEASE  VERIFY  THAT                  ***
echo ***       THE FOLLOWING PARAMETERS ARE CORRECT:              ***
echo *                                                              *
ECHO ****************************************************************
ECHO .
echo         Destination:    %1
echo              Format:    %2 inch
echo .
echo .
echo       Press Ctrl_C or Ctrl_Break to quit and begin again.
PAUSE
IF exist %1\*.* goto OldOne

Echo **** 
Echo **** Creating Directories...
Echo **** 
echo                %1
md %1
goto committed

:OldOne
Echo *****        You chose to install the Professional Toolkit 
Echo *****         in subdirectories under an existing directory.
Echo *****                    If this is NOT correct,
Echo *****         Press Ctrl_C or Ctrl_Break NOW!
Pause
:committed
 copy  \*.*  %1 > nul
 %1\tksetup1.bat  %1 %2

:usage
echo.
echo  Usage: TKSETUP  {destination}  {disk type} 
echo.
echo      Destination:
echo                   The *FULL* path to the destination
echo                   directory, including the drive name.
echo.
echo                    The source drive will be the current
echo                     drive from which TKSETUP is run.
echo                     Please read the README.TXT file.
echo.
echo        This can be an existing directory.
echo.
echo                    If it is, the 6 files and 7 subdirectories
echo                    will be appended to this directory.
echo.
pause
echo.
echo        Disk Type: 5.25" (1.2 meg) or  3.5" (1.44 meg) only.
echo.
echo                   This setup will not work with
echo                   low-density disks.
echo.
echo      Examples:          TKSETUP  C:\VB 3.5
echo                     OR  TKSETUP  C:\VB 5.25
echo                     OR  TKSETUP  C:\VBPLUS 3.5
echo                     OR  TKSETUP  C:\VBPLUS 5.25

