DECLARE SUB SURFER (NX%, NY%, DXX!, DYY!, QQ$)
DECLARE SUB AMPMAX (NX%, NY%, AMAX!, AMIN!)
DECLARE SUB CREATEXY (NX2%, NY2%)
DECLARE SUB CREATEA (NX2%, NY2%)
DECLARE SUB AMPTUDE (NX2%, NY2%)
DECLARE SUB EDGES (NX%, NX2%, NY%, NY2%, KR%, KL%, IT%, IB%, DC!)
DECLARE SUB AVERAGE (NX%, NY%, DC!)
DECLARE SUB SHIFT (NX%, NX2%, NY%, NY2%, KR%, KL%, IT%, IB%)
DECLARE SUB XYFIND (NX2%, NY2%)
DECLARE SUB LOWPASS (DX, DY, AX1, AX2, NX2%, NY2%, AAQ)
DECLARE SUB XYPRINT (NX2%, NY2%)
DECLARE SUB XYREAD (NX%, NY%)
DECLARE SUB POWER (NX%, NY%, NX2%, NY2%, PX2!, PY2!)
DECLARE SUB HARM (M%(), INV%(), S(), ifset%, IFERR%)
     
      DEFINT I-N
      CLS : PRINT "FREE MEMORY AT START "; FRE(-1)
      '$DYNAMIC

      DIM SHARED A(17000), INV(500), S(500), M(3)
      DIM SHARED NP(3), W(2), W2(2), W3(2), XY(128, 128), AMP(128, 128)
      CLS : COLOR 14, 1: CLS
      PRINT "FREE MEMORY AFTER DIMENSION"; FRE(-1)
REM INPUT "ENTER TO CONTINUE ",JUNK$
REM REMOVE ABOVE "REM" TO DISPLAY MEMORY REQUIREMENTS

   REM INPUT NECESSARY PARAMETERS
     
      LOCATE 5, 5
      INPUT "ENTER THE NUMBER OF X AXIS POINTS AND INCREMENT ", NX, DXX
      INPUT "ENTER THE NUMBER OF Y AXIS POINTS AND INCREMENT ", NY, DYY
     
      CALL XYREAD(NX, NY)  'READ IN TWO DIMENSIONAL DATA
     
      LOCATE 10, 10
      PRINT "ENTER THE NAMES OF OUTPUT FILES AS REQUESTED"
      PRINT "NOTE THESE ARE ALL OUTPUT FILES AND WILL BE IN SURFER GRD FORMAT"
      PRINT "FILES MAY BE VIEWED IMMEDIATELY THROUGH TOPO": PRINT
      PRINT "THE LACK OF A NAME IMPLIES DATA WILL NOT BE SAVED"
      PRINT : PRINT
      INPUT "ENTER NAME OF FILE FOR ORIGINAL SIGNAL ", OSIG$
     
      INPUT "ENTER NAME OF FILE FOR ORIGINAL AMPLITUDE SPECTRA ", AMP$
                IF AMP$ > " " THEN
                PRINT "       AMPLITUDE SPECTRUM DOMINATED BY DC TERM"
                PRINT "       TO VIEW SPECTRUM YOU MAY WISH TO SUPRESS DC TERM"
                INPUT "       TO SUPRESS, IN VIEW FILE ONLY, ENTER 1 ", DCAMP
                END IF
      PRINT
      INPUT "ENTER NAME OF FILE FOR FILTERED AMPLITUDE SPECTRA ", AMPF$
                IF AMPF$ > " " THEN
                PRINT "     FILTERED AMPLITUDE SPECTRUM MAY BE DOMINATED BY DC TERM"
                PRINT "     TO VIEW SPECTRUM YOU MAY WISH TO SUPRESS DC TERM"
                INPUT "     TO SUPRESS, IN VIEW FILE ONLY, ENTER 1 ", DCAMPF
                END IF
      PRINT
      INPUT "ENTER NAME OF FILE FOR FILTERED SIGNAL ", FILSIG$
     
     
     IF OSIG$ > " " THEN  'SAVE ORIGINAL DATA IF REQUESTED
         FOR I = 1 TO NY
         FOR K = 1 TO NX
         AMP(K, I) = XY(K, I)
         NEXT K
         NEXT I
         CALL SURFER(NX, NY, DXX, DYY, OSIG$)
        
         ERASE AMP
         DIM AMP(128, 128)
      END IF
     
     
      CALL POWER(NX, NY, NX2, NY2, PX2, PY2)  'FIND POWER OF 2
      PRINT
      PRINT "NX2 NY2 PX2 AND PY2 ARE "; NX2; NY2; PX2; PY2
     
     
      CALL AVERAGE(NX, NY, DC)                       'FIND DC VALUE
      PRINT : PRINT "AVERAGE VALUE IS ", DC
     
   REM SHIFT NX BY NY DATA ARRAY TO CENTER OF NX2 BY NY2 ARRAY
     
      CALL SHIFT(NX, NX2, NY, NY2, KR, KL, IT, IB)   'SHIFT INPUT DATA TO CENTER
      PRINT : PRINT "LEFT SHIFT AND TOP SHIFT ARE ", KL, IT
      ERASE XY
     
      CALL EDGES(NX, NX2, NY, NY2, KR, KL, IT, IB, DC)  'TAPER DATA EDGES
     


     
      'CREATE COMPLEX ARRAY FOR HARM
     
      CK = 1
      FOR I = 1 TO NY2
      FOR K = 1 TO NX2
      A(CK) = AMP(K, I)
      A(CK + 1) = 0
      CK = CK + 2
      NEXT K
      NEXT I
     
     
      M(1) = PX2: M(2) = PY2: M(3) = 0
     
     
       CALL HARM(M%(), INV%(), S(), 1, IFERR%)   'FIND FOURIER TRANSFORM
       
   REM NOTE FROM HERE ON WE ARE IN THE FREQUENCY DOMAIN
  
          'CALCULATE NECESSARY FREQUENCY DOMAIN PARAMETERS
       DX = 1 / (NX2 * DXX): DY = 1 / (NY2 * DYY)
       XMAX = 1 / (2 * DXX): YMAX = 1 / (2 * DYY)
       IF XMAX <= YMAX THEN FF = XMAX ELSE FF = YMAX
      
       PRINT : PRINT  'PRINT OUT FREQUENCY DOMAIN PARAMETERS
       PRINT "X AND Y FREQUENCY INCREMENTS ARE ", DX, DY
       PRINT "MAX X AND Y FREQUENCIES ARE ", XMAX, YMAX
       PRINT
      
       IF AMP$ > " " THEN   'SAVE AMPLITUDE SPECTRUM IF REQUESTED
            CALL AMPTUDE(NX2, NY2)
            IF DCAMP > .5 THEN AMP(1, 1) = 0'SUPRESS DC TERM IF REQUESTED
            CALL SURFER(NX2 / 2 + 1, NY2 / 2 + 1, DX, DY, AMP$)
       END IF
       ERASE AMP
       
      
       INPUT "ENTER 1 FOR LOWPASS  2 FOR HIGH PASS  3 FOR BAND PASS  4 TO EXIT ", AAQ
       PRINT : PRINT
      

    IF AAQ = 1 THEN
        PRINT "ENTER START AND STOP OF LOW PASS ROLL OFF"
        PRINT "IF IN DOUBT TRY ", FF / 2; ","; FF
        INPUT "START AND STOP OF ROLL OFF ARE ", AX1, AX2
    ELSEIF AAQ = 2 THEN
        PRINT "ENTER START AND STOP OF HIGH PASS ROLL OFF"
        PRINT "IF IN DOUBT TRY ", 2 * DX; ","; 10 * DX
        INPUT "START AND STOP OF ROLL OFF ARE ", AX1, AX2

    ELSEIF AAQ = 3 THEN
       PRINT "ENTER START AND STOP OF HIGH FREQUENCY ROLL OFF "
       PRINT "IF IN DOUBT ENTER "; FF / 1.5; ","; FF
       INPUT "STOP AND STOP OF HIGH FREQUENCY ROLL OFF ARE "; AX1, AX2
       PRINT : PRINT
       PRINT "ENTER START AND STOP OF LOW FREQUENCY ROLL OFF "
       PRINT "IF IN DOUBT ENTER "; 2 * DX; ","; 10 * DX
       INPUT "START AND STOP OF LOW FREQUENCY ROLL OFF ARE", BX1, BX2
    ELSEIF AAQ = 4 THEN
        CLS : LOCATE 10, 20
        PRINT "PROGRAM TERMINATED BY OPERATOR REQUEST "
    END IF
       
       CLS : LOCATE 10, 15
       PRINT "INPUTS COMPLETED "
       PRINT : PRINT "PLEASE STAND BY "
      
       DIM XY(128, 65)
       CALL CREATEXY(NX2, NY2)     'CREATE XY ARRAY FOR FILTER TO OPERATE ON
      
       IF AAQ = 3 THEN FC = 1 ELSE FC = AAQ
       CALL LOWPASS(DX, DY, AX1, AX2, NX2, NY2, FC)   'FILTER THE DATA
       IF AAQ > 2 THEN
           CALL LOWPASS(DX, DY, BX1, BX2, NX2, NY2, 2)  'FILTER AGAIN IF BANDPASS
       END IF
      
       CALL CREATEA(NX2, NY2)         'CREATE A ARRAY FOR HARM FROM XY ARRAY
       ERASE XY
       DIM AMP(128, 128)

             IF AMPF$ > " " THEN    'STORE FILTERED AMPLITUDE IF REQUESTED
                CALL AMPTUDE(NX2, NY2)
                IF AMPF > .5 THEN AMP(1, 1) = 0'SUPRESS DC TERM IF REQUESTED
                CALL SURFER(NX2 / 2 + 1, NY2 / 2 + 1, DX, DY, AMPF$)
             END IF
      
      CALL HARM(M%(), INV%(), S(), -1, IFERR%) 'TRANSFORM BACK TO SPACE DOMAIN
     
  REM   NOTE WE ARE NOW BACK IN THE SPACE DOMAIN
     
      ERASE AMP
     
      VI = 0
      INPUT "ENTER 1 TO VIEW IMAGINARY PART OF FILTERED SIGNAL SHOULD ALL BE ZERO ", VI
      IF VI > .5 THEN
           FOR KK = 2 TO 2 * NX2 * NY2 STEP 10
           PRINT A(KK); A(KK + 2); A(KK + 4); A(KK + 6); A(KK + 8)
           NEXT KK
      END IF

      DIM XY(128, 128)
     
      CALL XYFIND(NX2, NY2)    'FIND FILTERED SIGNAL AS REAL PART OF TRANSFORM
      ERASE A
      DIM AMP(128, 128)
     
      FOR I = 1 TO NY   'REMOVE EDGES OF ARRAY TO GET BACK TO ORIGINAL
      FOR K = 1 TO NX                                   'NX BY NY SIZE
      AMP(K, I) = XY(K + KL, I + IT)
      NEXT K
      NEXT I
     
             
          IF FILSIG$ > " " THEN     'STORE FILTERED SIGNAL IF REQUESTED
            CALL SURFER(NX, NY, DXX, DYY, FILSIG$)
          END IF


      CLS
      LOCATE 5, 5
      IF OSIG$ > " " THEN PRINT "ORIGINAL SIGNAL STORED IN ", OSIG$ ELSE PRINT "ORIGINAL SIGNAL NOT STORED "
      IF AMP$ > " " THEN PRINT "ORIGINAL AMPLITUDE STORED IN ", AMP$ ELSE PRINT "ORIGINAL AMPLITUDE NOT STORED "
      IF AMPF$ > " " THEN PRINT "FILTERED AMPLITUDE STORED IN ", AMPF$ ELSE PRINT "FILTERED AMPLITUDE NOT STORED"
      IF FILSIG$ > " " THEN PRINT "FILTERED SIGNAL STORED IN ", FILSIG$ ELSE PRINT "FILTERED SIGNAL NOT STORED"
      PRINT : PRINT : PRINT
     
      IF AAQ = 1 THEN
        PRINT "SIGNAL LOW PASS FILTERED FROM DC TO "; AX2
      ELSEIF AAQ = 2 THEN
        PRINT "SIGNAL HIGH PASS FILTERED FROM "; BX1; " TO "; FF
      ELSEIF AAQ = 3 THEN
        PRINT "SIGNAL BAND PASS FILTERED BETWEEN "; BX1; " AND "; AX2; "CYCLES PER DISTANCE"
      END IF

    PRINT : PRINT
    PRINT "              FILTERING COMPLETE"

END

REM $STATIC
            SUB AMPMAX (NX, NY, AMAX, AMIN)
            AMAX = 0: AMIN = AMP(1, 1)
            YLIM = NY
            XLIM = NX
         FOR I = 1 TO YLIM
         FOR K = 1 TO XLIM
         TESTMAX = AMP(K, I)
         TESTMIN = AMP(K, I)
         IF TESTMAX > AMAX THEN AMAX = TESTMAX
         IF TESTMIN < AMIN THEN AMIN = TESTMIN
         NEXT K
         NEXT I
END SUB

       SUB AMPTUDE (NX2, NY2)
       ds% = 1: de% = 2 * NX2: K = 0
     
       FOR npy = 1 TO NY2
       FOR J = ds% TO de% STEP 2
       K = K + 1
       AMP(K, npy) = SQR(A(J) ^ 2 + A(J + 1) ^ 2)
       NEXT J
       ds% = 1 + de%: de% = de% + 2 * NX2
       K = 0
       NEXT npy

END SUB

      SUB AVERAGE (NX, NY, DC)
        SUM = 0
        FOR I = 1 TO NY
        FOR K = 1 TO NX
        SUM = SUM + XY(I, K)
        NEXT K
        NEXT I
        DC = SUM / (NX * NY)
END SUB

          SUB CREATEA (NX2, NY2)
      'CREATE COMPLEX ARRAY FOR HARM
    
      IK = 1
      FOR I = 1 TO NY2
      FOR K = 1 TO 2 * NX2 STEP 2
      A(IK) = XY(K, I)
      A(IK + 1) = XY(K + 1, I)
      IK = IK + 2
      NEXT K
      NEXT I

END SUB

      SUB CREATEXY (NX2, NY2)
       
           'CREATE XY WITH REAL AND IMAGINARY VALUES OF A
       
        L = 1
        FOR I = 1 TO NY2
        FOR K = 1 TO 2 * NX2 STEP 2
        XY(K, I) = A(L)
        XY(K + 1, I) = A(L + 1)
        L = L + 2
        NEXT K
        NEXT I
END SUB

      SUB EDGES (NX, NX2, NY, NY2, KR, KL, IT, IB, DC)
        ALF = 1
        FOR K = 1 TO KL
        FOR I = IT + 1 TO IT + NY
        AMP(K, I) = DC + (AMP(KL + 1, I) - DC) * EXP(ALF * (K - KL - 1))
        NEXT I
        NEXT K
        FOR K = NX + KL + 1 TO NX2
        FOR I = IT + 1 TO IT + NY
        AMP(K, I) = DC + (AMP(NX + KL, I) - DC) * EXP(ALF * (NX + KL - K))
        NEXT I
        NEXT K
        FOR I = 1 TO IT
        FOR K = 1 TO NX2
        AMP(K, I) = DC + (AMP(K, IT + 1) - DC) * EXP(ALF * (I - IT - 1))
        NEXT K
        NEXT I
        FOR I = IT + NY + 1 TO NY2
        FOR K = 1 TO NX2
        AMP(K, I) = DC + (AMP(K, IT + NY) - DC) * EXP(ALF * (IT + NY - I))
        NEXT K: NEXT I
END SUB

DEFSNG I-N
SUB HARM (M%(), INV%(), S(), ifset%, IFERR%)
   DEFINT I-N
10 IF (ABS(ifset) - 1) <= 1 THEN GOTO 900 ELSE GOTO 12
12        mtt = 0
        FOR J = 1 TO 3
        IF M(J) > mtt THEN mtt = M(J)
        NEXT J
        mtt = mtt - 2
      ROOT2 = SQR(2!)
      IF mtt < 2 THEN GOTO 13 ELSE GOTO 14
      IF mtt > 12 THEN GOTO 13 ELSE GOTO 14
13 IFERR = 1
      CLS : PRINT "np too large or too small"
      GOTO 1000
14 IFERR = 0
      M1 = M(1)
      M2 = M(2)
      M3 = M(3)
      N1 = 2 ^ M1
      N2 = 2 ^ M2
      N3 = 2 ^ M3
16 IF ifset <= 0 THEN GOTO 18 ELSE GOTO 20
18 NX = N1 * N2 * N3
      QQN = NX
      FOR I = 1 TO NX
      A(2 * I - 1) = A(2 * I - 1) / QQN
19 A(2 * I) = -A(2 * I) / QQN
      NEXT I
20 NP(1) = N1 * 2
      NP(2) = NP(1) * N2
      NP(3) = NP(2) * N3
      FOR id = 1 TO 3       'end 250
      IL = NP(3) - NP(id)
      IL1 = IL + 1
      MI = M(id)
      IF MI <= 0 THEN GOTO 250
30 IDIF = NP(id)
      KBIT = NP(id)
      MEV = 2 * (MI / 2)
      IF (MI - MEV) <= 0 THEN GOTO 60
40 KBIT = KBIT / 2
      KL = KBIT - 2
      FOR I = 1 TO IL1 STEP IDIF  'end 50
      KLAST = KL + I
      FOR K = I TO KLAST STEP 2      'end 50
      KD = K + KBIT
      T = A(KD)
      A(KD) = A(K) - T
      A(K) = A(K) + T
      T = A(KD + 1)
      A(KD + 1) = A(K + 1) - T
50 A(K + 1) = A(K + 1) + T
      NEXT K
      NEXT I
      IF (MI - 1) <= 0 THEN GOTO 250 ELSE GOTO 52
52 LFIRST = 3
      JLAST = 1
      GOTO 70
60 LFIRST = 2
      JLAST = 0
70 FOR L = LFIRST TO MI STEP 2          'end 240
      JJDIF = KBIT
      KBIT = KBIT / 4
      KL = KBIT - 2
      FOR I = 1 TO IL1 STEP IDIF        'end 80
      KLAST = I + KL
      FOR K = I TO KLAST STEP 2            'end 80
      K1 = K + KBIT
      K2 = K1 + KBIT
      K3 = K2 + KBIT
      T = A(K2)
      A(K2) = A(K) - T
      A(K) = A(K) + T
      T = A(K2 + 1)
      A(K2 + 1) = A(K + 1) - T
      A(K + 1) = A(K + 1) + T
      T = A(K3)
      A(K3) = A(K1) - T
      A(K1) = A(K1) + T
      T = A(K3 + 1)
      A(K3 + 1) = A(K1 + 1) - T
      A(K1 + 1) = A(K1 + 1) + T
      T = A(K1)
      A(K1) = A(K) - T
      A(K) = A(K) + T
      T = A(K1 + 1)
      A(K1 + 1) = A(K + 1) - T
      A(K + 1) = A(K + 1) + T
      r = -A(K3 + 1)
      T = A(K3)
      A(K3) = A(K2) - r
      A(K2) = A(K2) + r
      A(K3 + 1) = A(K2 + 1) - T
80 A(K2 + 1) = A(K2 + 1) + T
      NEXT K
      NEXT I
      IF JLAST <= 0 THEN GOTO 235
82 JJ = JJDIF + 1
      ILAST = IL + JJ
      FOR I = JJ TO ILAST STEP IDIF            'end 85
      KLAST = KL + I
      FOR K = I TO KLAST STEP 2                 'end 85
      K1 = K + KBIT
      K2 = K1 + KBIT
      K3 = K2 + KBIT
      r = -A(K2 + 1)
      T = A(K2)
      A(K2) = A(K) - r
      A(K) = A(K) + r
      A(K2 + 1) = A(K + 1) - T
      A(K + 1) = A(K + 1) + T
      AWR = A(K1) - A(K1 + 1)
      AWI = A(K1 + 1) + A(K1)
      r = -A(K3) - A(K3 + 1)
      T = A(K3) - A(K3 + 1)
      A(K3) = (AWR - r) / ROOT2
      A(K3 + 1) = (AWI - T) / ROOT2
      A(K1) = (AWR + r) / ROOT2
      A(K1 + 1) = (AWI + T) / ROOT2
      T = A(K1)
      A(K1) = A(K) - T
      A(K) = A(K) + T
      T = A(K1 + 1)
      A(K1 + 1) = A(K + 1) - T
      A(K + 1) = A(K + 1) + T
      r = -A(K3 + 1)
      T = A(K3)
      A(K3) = A(K2) - r
      A(K2) = A(K2) + r
      A(K3 + 1) = A(K2 + 1) - T
85 A(K2 + 1) = A(K2 + 1) + T
      NEXT K
      NEXT I
      IF (JLAST - 1) <= 0 THEN GOTO 235 ELSE GOTO 90
90 JJ = JJ + JJDIF
      FOR J = 2 TO JLAST           'end 230
96 I = INV(J + 1)
98 IC = NT - I
      W(1) = S(IC)
      W(2) = S(I)
      I2 = 2 * I
      i2c = NT - I2
      IF i2c < 0 THEN GOTO 120
      IF i2c = 0 THEN GOTO 110 ELSE GOTO 100
100 W2(1) = S(i2c)
      W2(2) = S(I2)
      GOTO 130
110 W2(1) = 0!
      W2(2) = 1!
      GOTO 130
120 I2CC = i2c + NT
      i2c = -i2c
      W2(1) = -S(i2c)
      W2(2) = S(I2CC)
130 I3 = I + I2
      I3C = NT - I3
      IF I3C < 0 THEN GOTO 160
      IF I3C = 0 THEN GOTO 150 ELSE GOTO 140
140 W3(1) = S(I3C)
      W3(2) = S(I3)
      GOTO 200
150 W3(1) = 0!
      W3(2) = 1!
      GOTO 200
160 i3cc = I3C + NT
      IF i3cc < 0 THEN GOTO 190
      IF i3cc = 0 THEN GOTO 180 ELSE 170
170 I3C = -I3C
      W3(1) = -S(I3C)
      W3(2) = S(i3cc)
      GOTO 200
180 W3(1) = -1!
      W3(2) = 0!
      GOTO 200
190 I3CCC = NT + i3cc
      i3cc = -i3cc
      W3(1) = -S(I3CCC)
      W3(2) = -S(i3cc)
200 ILAST = IL + JJ
      FOR I = JJ TO ILAST STEP IDIF       'end 220
      KLAST = KL + I
      FOR K = I TO KLAST STEP 2          'end 220
      K1 = K + KBIT
      K2 = K1 + KBIT
      K3 = K2 + KBIT
      r = A(K2) * W2(1) - A(K2 + 1) * W2(2)
      T = A(K2) * W2(2) + A(K2 + 1) * W2(1)
      A(K2) = A(K) - r
      A(K) = A(K) + r
      A(K2 + 1) = A(K + 1) - T
      A(K + 1) = A(K + 1) + T
      r = A(K3) * W3(1) - A(K3 + 1) * W3(2)
      T = A(K3) * W3(2) + A(K3 + 1) * W3(1)
      AWR = A(K1) * W(1) - A(K1 + 1) * W(2)
      AWI = A(K1) * W(2) + A(K1 + 1) * W(1)
      A(K3) = AWR - r
      A(K3 + 1) = AWI - T
      A(K1) = AWR + r
      A(K1 + 1) = AWI + T
      T = A(K1)
      A(K1) = A(K) - T
      A(K) = A(K) + T
      T = A(K1 + 1)
      A(K1 + 1) = A(K + 1) - T
      A(K + 1) = A(K + 1) + T
      r = -A(K3 + 1)
      T = A(K3)
      A(K3) = A(K2) - r
      A(K2) = A(K2) + r
      A(K3 + 1) = A(K2 + 1) - T
220 A(K2 + 1) = A(K2 + 1) + T
       NEXT K
       NEXT I
230 JJ = JJDIF + JJ
        NEXT J
235 JLAST = 4 * JLAST + 3
REM   240 CONTINUE
      NEXT L
250   NEXT id
REM   250 CONTINUE
      NTSQ = NT * NT
      M3MT = M3 - mt
350 IF M3MT < 0 THEN GOTO 370
360 igo3 = 1
      N3VNT = N3 / NT
      MINN3 = NT
      GOTO 380
370 igo3 = 2
      N3VNT = 1
      NTVN3 = NT / N3
      MINN3 = N3
380 JJD3 = NTSQ / N3
      M2MT = M2 - mt
450 IF M2MT < 0 THEN GOTO 470
460 igo2 = 1
      N2VNT = N2 / NT
      MINN2 = NT
      GOTO 480
470 igo2 = 2
      N2VNT = 1
      NTVN2 = NT / N2
      MINN2 = N2
480 JJD2 = NTSQ / N2
      M1MT = M1 - mt
550 IF M1MT < 0 THEN GOTO 570
560 igo1 = 1
      N1VNT = N1 / NT
      MINN1 = NT
      GOTO 580
570 igo1 = 2
      N1VNT = 1
      NTVN1 = NT / N1
      MINN1 = N1
580 JJD1 = NTSQ / N1
600 JJ3 = 1
      J = 1
      FOR jpp3 = 1 TO N3VNT     'end 880
      IPP3 = INV(JJ3)
      FOR jp3 = 1 TO MINN3     'end 870
      IF igo3 = 2 THEN GOTO 620        'GO TO (610,620),IGO3
610 IP3 = INV(jp3) * N3VNT
      GOTO 630
620 IP3 = INV(jp3) / NTVN3
630 I3 = (IPP3 + IP3) * N2
700 JJ2 = 1
      FOR jpp2 = 1 TO N2VNT       'end 870
      IPP2 = INV(JJ2) + I3
      FOR jp2 = 1 TO MINN2        'end 860
      IF igo2 = 2 THEN GOTO 720    'GO TO (710,720),IGO2
710 IP2 = INV(jp2) * N2VNT
      GOTO 730
720 IP2 = INV(jp2) / NTVN2
730 I2 = (IPP2 + IP2) * N1
800 JJ1 = 1
      FOR jpp1 = 1 TO N1VNT           'end 860
      IPP1 = INV(JJ1) + I2
      FOR jp1 = 1 TO MINN1            'end 850
      IF igo1 = 2 THEN GOTO 820 ELSE GOTO 810  'GO TO (810,820),IGO1
810 IP1 = INV(jp1) * N1VNT
      GOTO 830
820 IP1 = INV(jp1) / NTVN1
830 I = 2 * (IPP1 + IP1) + 1
      IF (J - I) < 0 THEN GOTO 840 ELSE GOTO 845
840 T = A(I)
      A(I) = A(J)
      A(J) = T
      T = A(I + 1)
      A(I + 1) = A(J + 1)
      A(J + 1) = T
845 AQAQ = 2
850 J = J + 2
    NEXT jp1
860 JJ1 = JJ1 + JJD1
    NEXT jpp1
    NEXT jp2
870 JJ2 = JJ2 + JJD2
    NEXT jpp2
    NEXT jp3
880 JJ3 = JJ3 + JJD3
    NEXT jpp3
890 IF ifset < 0 THEN GOTO 891 ELSE GOTO 895
891 FOR I = 1 TO NX               'end 892
892 A(2 * I) = -A(2 * I)
    NEXT I
895 GOTO 1000
900 mt = M(1) - 2: IFERR = 0
      NT = 2 ^ mt
      NTV2 = NT / 2
910 THETA = .7853981634#
      JSTEP = NT
      JDIF = NTV2
      S(JDIF) = SIN(THETA)
      FOR L = 2 TO mt     'end 950
      THETA = THETA / 2!
      JSTEP2 = JSTEP
      JSTEP = JDIF
      JDIF = JSTEP / 2
      S(JDIF) = SIN(THETA)
      JC1 = NT - JDIF
      S(JC1) = COS(THETA)
      JLAST = NT - JSTEP2
      IF (JLAST - JSTEP) < 0 THEN GOTO 950
920 FOR J = JSTEP TO JLAST STEP JSTEP        'end 940
      JC = NT - J
      JD = J + JDIF
940 S(JD) = S(J) * S(JC1) + S(JDIF) * S(JC)
     NEXT J
REM  950 CONTINUE
950  NEXT L
960  MTLEXP = NTV2
      LM1EXP = 1
      INV(1) = 0
      FOR L = 1 TO mt    'end 980
      INV(LM1EXP + 1) = MTLEXP
      FOR J = 2 TO LM1EXP      'end 970
      JJ = J + LM1EXP
970 INV(JJ) = INV(J) + MTLEXP
      NEXT J
      MTLEXP = MTLEXP / 2
980 LM1EXP = LM1EXP * 2
     NEXT L
982 IF ifset = 0 THEN GOTO 895 ELSE GOTO 12
1000 AQAQ = 3
END SUB

       SUB LOWPASS (DX, DY, AX1, AX2, NX2, NY2, AAQ)
        CO = 3.14159 / (AX2 - AX1)
        PI2 = 3.14159 / 2
        L1Y = NY2 / 2 + 1: L1X = NX2 + 2: L2X = 2 * NX2
       
        IF AAQ = 1 THEN
           CF1 = 0
           CF2 = 1
           CF3 = 0
           CF4 = 1
         ELSEIF AAQ = 2 THEN
           CF1 = 1
           CF2 = -1
           CF3 = 1
           CF4 = 0
        END IF
       
       
        'QUAD 1
       
        FOR I = 1 TO L1Y
        y = DY * (I - 1)
        KC = 0
        FOR K = 1 TO L1X STEP 2
        KC = KC + 1
        X = DX * (KC - 1)
        r = SQR(X ^ 2 + y ^ 2)
        IF r < AX1 THEN GOTO 99
        IF r < AX2 THEN
           XY(K, I) = XY(K, I) * (CF1 + CF2 * ((1 + SIN(CO * (r - AX1) + PI2)) / 2))
           XY(K + 1, I) = XY(K + 1, I) * (CF1 + CF2 * ((1 + SIN(CO * (r - AX1) + PI2)) / 2))
        ELSE
        XY(K, I) = CF3 * XY(K, I)
        XY(K + 1, I) = CF3 * XY(K + 1, I)
        END IF
     GOTO 107

99  XY(K, I) = CF4 * XY(K, I)
    XY(K + 1, I) = CF4 * XY(K + 1, I)


107     NEXT K
       
       
     NEXT I
       
        'QUAD 3
        L = 0: N = 0
        FOR I = NY2 TO L1Y + 1 STEP -1
        L = L + 1
        y = DY * (L)
        N = 0
        FOR K = 1 TO L1X STEP 2
        N = N + 1
        X = DX * (N - 1)
        r = SQR(X ^ 2 + y ^ 2)
       
        IF r < AX1 THEN GOTO 97
        IF r < AX2 THEN
           XY(K, I) = XY(K, I) * (CF1 + CF2 * ((1 + SIN(CO * (r - AX1) + PI2)) / 2))
           XY(K + 1, I) = XY(K + 1, I) * (CF1 + CF2 * ((1 + SIN(CO * (r - AX1) + PI2)) / 2))
        ELSE
        XY(K, I) = CF3 * XY(K, I)
        XY(K + 1, I) = CF3 * XY(K + 1, I)
       END IF
    GOTO 109

97   XY(K, I) = CF4 * XY(K, I)
     XY(K + 1, I) = CF4 * XY

109     NEXT K
      
       NEXT I
      
       'QUAD 2
      
REM       PRINT "results for quad 2"
      
       L = 0: N = 0
       FOR I = 1 TO L1Y
       L = L + 1
       y = DY * (L - 1)
       N = 0
       FOR K = L2X TO L1X + 2 STEP -2
       N = N + 1
       X = DX * (N)
       r = SQR(X ^ 2 + y ^ 2)
REM        PRINT "x y and r are ", X, y, r
       
        IF r < AX1 THEN GOTO 93
        IF r < AX2 THEN
           XY(K, I) = XY(K, I) * (CF1 + CF2 * ((1 + SIN(CO * (r - AX1) + PI2)) / 2))
           XY(K - 1, I) = XY(K - 1, I) * (CF1 + CF2 * ((1 + SIN(CO * (r - AX1) + PI2)) / 2))
REM           PRINT "XY AND taper "; XY(K, I), XY(K - 1, I), ((1 + SIN(CO * (r - AX1) + PI2)) / 2)
        ELSE
        XY(K, I) = CF3 * XY(K, I)
        XY(K - 1, I) = CF3 * XY(K - 1, I)
        END IF
      GOTO 106
93       XY(K, I) = CF4 * XY(K, I)
        XY(K - 1, I) = CF4 * XY(K - 1, I)



106      NEXT K
REM        INPUT AAA$
        NEXT I
       
        'QUAD 4
       
        L = 0: N = 0
        FOR I = NY2 TO L1Y + 1 STEP -1
        L = L + 1
        y = DY * L
        N = 0
        FOR K = L2X TO L1X + 2 STEP -2
        N = N + 1
        X = DX * N
        r = SQR(X ^ 2 + y ^ 2)
        IF r < AX1 THEN GOTO 92
        IF r < AX2 THEN
           XY(K, I) = XY(K, I) * (CF1 + CF2 * ((1 + SIN(CO * (r - AX1) + PI2)) / 2))
           XY(K - 1, I) = XY(K - 1, I) * (CF1 + CF2 * ((1 + SIN(CO * (r - AX1) + PI2)) / 2))
        ELSE
        XY(K, I) = CF3 * XY(K, I)
        XY(K - 1, I) = CF3 * XY(K - 1, I)
        END IF
        GOTO 111
92      XY(K, I) = CF4 * XY(K, I)
        XY(K - 1, I) = CF4 * XY(K - 1, I)

111     NEXT K
        NEXT I

END SUB

      SUB POWER (NX, NY, NX2, NY2, PX2, PY2)
        DO
        NX2 = 2 ^ I
        I = I + 1
        LOOP UNTIL NX2 >= NX
        I = I - 1
        DO
        NY2 = 2 ^ K
        K = K + 1
        LOOP UNTIL NY2 >= NY
        K = K - 1
        S = I / 2: S% = INT(S): T = I - 2 * S%
        IF T > .001 THEN PX2 = I + 1 ELSE PX2 = I
        S = K / 2: S% = INT(S): T = K - 2 * S%
        IF T > .001 THEN PY2 = K + 1 ELSE PY2 = K
        NX2 = 2 ^ PX2: NY2 = 2 ^ PY2

END SUB

      SUB SHIFT (NX, NX2, NY, NY2, KR, KL, IT, IB)
        SO = (NX2 - NX) / 2
        KO = SO
        IF SO - KO > .0001 THEN I = 1 ELSE I = 0
        KL = KO: KR = KO + I
        SO = (NY2 - NY) / 2: IO = SO
        IF SO - IO > .0001 THEN I = 1 ELSE I = 0
        IT = IO: IB = IO + I
REM        PRINT "KL KR IT AND IB ARE  ", KL, KR, IT, IB
REM        INPUT AAA$
        FOR I = 1 TO NY
        FOR K = 1 TO NX
        AMP(K + KL, I + IT) = XY(K, I)
        NEXT K
        NEXT I
END SUB

      SUB SURFER (NX, NY, DXX, DYY, QQ$)
            CALL AMPMAX(NX, NY, AMAX, AMIN)
            OPEN QQ$ FOR OUTPUT AS #1
            FO = 0
            PRINT #1, "DSAA"
            PRINT #1, NX; NY
            PRINT #1, FO; (NX - 1) * DXX
            PRINT #1, FO; (NY - 1) * DYY
            PRINT #1, AMIN; AMAX
            FOR I = 1 TO NY
            LSTART = 1: LEND = 10
7           IF LSTART + 9 <= NX THEN LEND = LSTART + 9 ELSE LEND = NX
            FOR K = LSTART TO LEND
            PRINT #1, AMP(K, I);
            NEXT K
            PRINT #1,
            LSTART = LSTART + 10
            IF LSTART <= NX THEN GOTO 7
            PRINT #1,
            NEXT I
            CLOSE #1

END SUB

      SUB XYFIND (NX2, NY2)
       
           'CREATE XY FROM REAL PART OF A ARRAY
       
        KS = 1: KE = 2 * NX2: J = 1: I = 1
8     FOR K = KS TO KE STEP 2
        XY(J, I) = A(K)
        J = J + 1
      NEXT K
       
        I = I + 1
        KS = KE + 1
        KE = KE + 2 * NX2
        J = 1
        IF I > NY2 THEN EXIT SUB ELSE GOTO 8
END SUB

       SUB XYPRINT (NX2, NY2)
       LPRINT CHR$(27) + CHR$(79);
       K = 1
25       FOR NY = 1 TO NY2 / 2
       LPRINT USING "####.###"; AMP(K, NY); AMP(K + 1, NY); AMP(K + 2, NY); AMP(K + 3, NY); AMP(K + 4, NY); AMP(K + 5, NY); AMP(K + 6, NY); AMP(K + 7, NY)
       LPRINT
       NEXT NY
       LPRINT : LPRINT : LPRINT
       K = K + 8
       IF K <= NX2 / 2 THEN GOTO 25 ELSE GOTO 49
49     LPRINT : LPRINT : LPRINT "end first print ": LPRINT : LPRINT


51     FOR NY = 1 TO NY2 / 2
       LPRINT USING "####.###"; AMP(K, NY); AMP(K + 1, NY); AMP(K + 2, NY); AMP(K + 3, NY); AMP(K + 4, NY); AMP(K + 5, NY); AMP(K + 6, NY); AMP(K + 7, NY)
       LPRINT
       NEXT NY
       LPRINT : LPRINT : LPRINT
       K = K + 8
       IF K <= NX2 THEN GOTO 51 ELSE 65
     
65     LPRINT : LPRINT : LPRINT "end second print": LPRINT : LPRINT
       K = 1
66     FOR NY = NY2 / 2 + 1 TO NY2
       LPRINT USING "####.###"; AMP(K, NY); AMP(K + 1, NY); AMP(K + 2, NY); AMP(K + 3, NY); AMP(K + 4, NY); AMP(K + 5, NY); AMP(K + 6, NY); AMP(K + 7, NY)
       LPRINT
       NEXT NY
       LPRINT : LPRINT : LPRINT
       K = K + 8
       IF K <= NX2 / 2 THEN GOTO 66
       LPRINT : LPRINT : LPRINT : LPRINT "END THIRD PRINT ": LPRINT : LPRINT
71     FOR NY = NY2 / 2 + 1 TO NY2
       LPRINT USING "####.###"; AMP(K, NY); AMP(K + 1, NY); AMP(K + 2, NY); AMP(K + 3, NY); AMP(K + 4, NY); AMP(K + 5, NY); AMP(K + 6, NY); AMP(K + 7, NY)
       LPRINT
       NEXT NY
       LPRINT : LPRINT : LPRINT : LPRINT
       K = K + 8
       IF K <= NX2 THEN GOTO 71

       LPRINT : LPRINT : LPRINT : LPRINT "END FORTH PRINT ": LPRINT : LPRINT

END SUB

SUB XYREAD (NX, NY)
       
        LOCATE 10, 20:
        INPUT "ENTER NAME OF DATA FILE WITH EXTENSION  ", AW$
        OPEN AW$ FOR INPUT AS #1
        CLS
        LOCATE 5, 10
        INPUT "ENTER 1 IF FILE IS X,Y,Z OR 0 IF JUST Z ", RT
       
        FOR I = 1 TO NY
        FOR K = 1 TO NX
        IF RT > .5 THEN INPUT #1, XC, YC, XY(K, I) ELSE INPUT #1, XY(K, I)
        NEXT K
        NEXT I
        CLOSE #1
END SUB

