'Program = = DATIMTST.BAS = = Test the Date/Time library

DEFINT A-Z
'$INCLUDE: 'DATIM.BI'

DATA Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday
DIM Week$(7)
FOR I = 1 TO 7: READ Week$(I): NEXT I

CLS

PRINT "Date/Time library exerciser": PRINT

INPUT "Enter your birthdate (mm/dd/yy): "; BD$
CLS
IF BD$ <> "" THEN
	BDSerial# = DateValue#(BD$)      'Convert date in string to serial #
END IF

'Print the day of the week you were born in words not numbers

PRINT "You were born on a "; Week$(Weekday&(BDSerial#))

NbrDays& = Now# - DateSerial#(69, 7, 23)
PRINT "It's been"; NbrDays&;
PRINT "days since humans first walked on the moon."

NYDaySerial# = DateSerial#(2001, 1, 1)
NbrDays& = NYDaySerial# - Now#

PRINT "It's"; NbrDays&;
PRINT "days until the first day of the next millenium."
'Better get your date routines in order
PRINT "By the way, the first New Year's day of the next millineaum";
PRINT " is on a "; Week$(Weekday&(NYDaySerial#)); "."; "Figures."

NextWeek# = Now# + 7
PRINT
PRINT "One week from now will be day"; Day&(NextWeek#)
PRINT "              of month number"; Month&(NextWeek#)
PRINT "                  of the year"; Year&(NextWeek#)

PRINT
PRINT "DateValue# accepts the additional date formats:"
PRINT : PRINT "Format       Serial number for August 1, 1991": PRINT
PRINT "mmm dd, yyyy: "; DateValue#("AUG 1, 1991")
PRINT " dd mmm yyyy: "; DateValue#("1 aug 1991")
PRINT " dd-mmm-yyyy: "; DateValue#("1-aUg-91")
PRINT "  mm-dd-yyyy: "; DateValue#("8-1-91")

PRINT : PRINT "Print the results of some time calculations": PRINT

CurTime# = Now#
CurTime# = CurTime# - INT(CurTime#)

PRINT "It's "; (TimeSerial#(12, 0, 0) - CurTime#) * 24;
PRINT "hours till/since lunch."


