'******************************************************************************
'*             General include file voor PowerBasic 3 routines               *
'*                      (c) Hans Lunsing - 04/1993                            *
'******************************************************************************


'********************* Declaration of constants **********************************

' Boolean waarden:

%TRUE = -1
%FALSE = 0

' Video adapters:

'pbvScrnCard    byt  read only   screen video card descriptor 'values???
'                                bit 0 = mono   bit 1 = cga   bit 2 = egamono
'                                bit 3 = egaclr bit 5 = vga   bit 6 = hercules
'                                bit 4 ?
'Each of these bits is set on an inclusive basis.  That means a VGA card
'would set bits 1, 3, and 5.  So you can simply test a bit to see if a
'particular mode is supported on the card running.
'
'Example: a value of 58 would mean => vga/egacolor/cga.

%MONO = 1		   'monochroom, niet EGA
%CGA = 2		   'CGA
%EGAMONO = 4		   'monochroom EGA
%EGACLR = 8		   'EGA
%VGA = 32		   'VGA
%HERC = 64		   'Hercules

' Toetsen

%LF = 10
%CR = 13
%TAB = 9

' Registers

%FLAGS = 0
%AX    = 1
%BX    = 2
%CX    = 3
%DX    = 4
%SI    = 5
%DI    = 6
%BP    = 7
%DS    = 8
%ES    = 9

'**************** FUNCTION en SUB declaraties *********************************

DECLARE FUNCTION BlinkStatus ()
DECLARE FUNCTION GetActiveColor ()
DECLARE FUNCTION GetKey ()
DECLARE FUNCTION GetVideoMode ()
DECLARE FUNCTION MakeChar$ (BYVAL INTEGER)
DECLARE FUNCTION MakeKey (STRING)
DECLARE SUB Attr (BYVAL INTEGER, BYVAL INTEGER)
DECLARE SUB Browse (STRING, BYVAL INTEGER, BYVAL INTEGER, BYVAL INTEGER, _
	BYVAL INTEGER, BYVAL INTEGER, BYVAL INTEGER, BYVAL INTEGER, INTEGER)
DECLARE SUB ClearLines (BYVAL INTEGER, BYVAL INTEGER)
DECLARE FUNCTION GetActiveColor ()
DECLARE SUB GetAttr (INTEGER, INTEGER)
DECLARE SUB GetVideoAddress (INTEGER, INTEGER)
DECLARE FUNCTION GetVideoMode ()
DECLARE SUB InvertColor (BYVAL INTEGER, BYVAL INTEGER, INTEGER, INTEGER)
