        ':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        ':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        ':::                                                                 :::
        ':::                                                                 :::
        ':::    PROGRAM:        SHARE.BAS                                    :::
        ':::    AUTHOR:         Mike Shaffer                                 :::
        ':::    DATE:           Feb 2, 1991                                  :::
        ':::    VERSION:        2.0                                          :::
        ':::    PURPOSE:        Tests the ISSHARE.SUB subroutine             :::
        ':::    REVISIONS:                                                   :::
        ':::                                                                 :::
        ':::                                                                 :::
        ':::                                                                 :::
        ':::    NOTES:          This program assumes you're using PDQ from   :::
        ':::                    Crescent Software. If not (shame on you!)    :::
        ':::                    than you can modify the interrupt call to    :::
        ':::                    use INT86 as provided with QuickBASIC, and   :::
        ':::                    take out the reference to PDQDECL.BAS        :::
        ':::                                                                 :::
        ':::                    Compile using:                               :::
        ':::                                                                 :::
        ':::                         BC ISSHARE/o/s;                         :::
        ':::                         LINK /NOD/NOE ISSHARE,,,pdq[386].lib    :::
        ':::                                                                 :::
        ':::                    or similar...                                :::
        ':::                                                                 :::
        ':::                                                                 :::
        ':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        ':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        '
        '$include: 'pdqdecl.bas'


        call    ISSHARE(a%)
        if a% then
           print "DOS reports that SHARE is loaded..."
        else
           print "SHARE is apparently not loaded..."
        endif
        end


        '$include: 'ISSHARE.SUB'

