' LJDEMO.BAS--A program demonstrating PCL job control commands.
' Includes the file COPIES.BAS

CLS
PRINT "This program prints from 1 to 99 copies of a page."
PRINT

DO
  INPUT "How many copies would you like to print:  ", copies%
LOOP UNTIL (copies% > 0) AND (copies% < 100)

LPRINT CHR$(27); "E"	' Reset printer
LPRINT CHR$(27); "&l"; copies%; "X"	' Set copies

LPRINT "You asked for"; copies%; "copies of this page"

LPRINT CHR$(27); "E"	' Reset printer and eject pages

LPRINT CHR$(27); "E"	' Reset printer
LPRINT CHR$(27); "(8U"	' Set symbol set
LPRINT CHR$(27); "(s0p16.66h0s0b0T"	' Set font characteristics
LPRINT "Lineprinter is beautiful"	' Print message
LPRINT CHR$(27); "E"	' Reset printer/eject page

LPRINT CHR$(27); "E"	' Reset printer
LPRINT CHR$(27); "(0U"	' Set symbol set
LPRINT CHR$(27); "(s1p14v0s3b4T"	' Set font characteristics
LPRINT "Fun with Helvetica"	' Print message
LPRINT "CHR$(27); "E"	' Reset printer/eject page

size% = 4	' Set initial height

LPRINT CHR$(27); "E"	' Reset printer
LPRINT CHR$(27); "(10U"	' Set symbol set
LPRINT CHR$(27); "(s1p"; size%; "v0s0b4101T"	' Set font

FOR i% = 1 TO 15	' Loop 15 times
  LPRINT "CG Times"; size%; "point"	' Print message
  LPRINT
  size% = size% + 2	' Increment size%
  LPRINT CHR$(27); "(s"; size%; "V"	' Set new height
NEXT i%

LPRINT CHR$(27); "E"	' Reset printer

