DECLARE SUB LjBox (LjX!, LjY!, LjWidth!, LjHeight!, LjThick!, LjLineFillPat$, LjBoxFillPat$)
DECLARE SUB LjEject ()
DECLARE SUB LjFill (LjX!, LjY!, LjWidth!, LjHeight!, LjFillPat$)
DECLARE SUB LjGoToXY (LjX!, LjY!)
DECLARE SUB LjLine (LjX!, LjY!, LjLength!, LjThick!, LjFillPat$, LjOr$)
DECLARE SUB LjSay (LjR!, LjC!, Text$)
DECLARE FUNCTION RStr$ (A!)

COMMON SHARED Esc$: Esc$ = CHR$(27)

WIDTH LPRINT 255

'Print sample boxes and text

LjBox 1!, 1.1, 4!, .3, .01, "100", "10"
  LjSay 7, 11, "COSTCODES"

LjBox 1!, 1.45, 4!, .6, .01, "100", ""
  LjSay 9, 11, "Costcode...:"
  LjSay 9, 24, "OI81"
  LjSay 10, 11, "Department.:"
  LjSay 10, 24, "X267"
  LjSay 11, 11, "Location...:"
  LjSay 11, 24, "45"

LjEject

END

SUB LjBox (LjX!, LjY!, LjWidth!, LjHeight!, LjThick!, LjLineFillPat$, LjBoxFillPat$)

  LjBoxFillPat$ = UCASE$(LjBoxFillPat$)
  LjLineFillPat$ = UCASE$(LjLineFillPat$)

  LjLine LjX!, LjY!, LjWidth!, LjThick!, LjLineFillPat$, "H"   'Top
  LjLine LjX!, LjY!, LjHeight!, LjThick!, LjLineFillPat$, "V"  'Left
  LjLine (LjX! + (LjWidth! - LjThick!)), LjY!, LjHeight!, LjThick!, LjLineFillPat$, "V"                                  'Right
  LjLine LjX!, (LjY! + (LjHeight! - LjThick!)), LjWidth!, LjThick!, LjLineFillPat$, "H"                                  'Bottom

'Fill the Box

  IF LjBoxFillPat$ <> "" THEN
    LjFill LjX!, LjY!, LjWidth!, LjHeight!, LjBoxFillPat$
  END IF

END SUB

SUB LjEject
  LPRINT CHR$(12)
END SUB

SUB LjFill (LjX!, LjY!, LjWidth!, LjHeight!, LjFillPat$)

  LjGoToXY LjX!, LjY!

  Sj$ = Esc$ + "*c" + STR$(300! * LjWidth!) + "a" + STR$(300! * LjHeight!) + "b"

  IF LEFT$(LjFillPat$, 1) = "#" THEN
    Sj$ = Sj$ + RIGHT$(LjFillPat$, 1) + "g3P"
  END IF

  IF VAL(LjFillPat$) <> 0 THEN
    Sj$ = Sj$ + LjFillPat$ + "g2P"
  END IF

  LPRINT Sj$;

END SUB

SUB LjGoToXY (LjX!, LjY!)

  Sj$ = Esc$ + "*p" + STR$(300! * LjX!) + "x" + STR$(300! * LjY!) + "Y"
  LPRINT Sj$;
END SUB

SUB LjLine (LjX!, LjY!, LjLength!, LjThick!, LjFillPat$, LjOr$)

  IF UCASE$(LjOr$) = "V" THEN
    LjFill LjX!, LjY!, LjThick!, LjLength!, LjFillPat$
  ELSE
    LjFill LjX!, LjY!, LjLength!, LjThick!, LjFillPat$
  END IF

END SUB

SUB LjReset
  LPRINT Esc$; "E";
END SUB

SUB LjSay (LjR!, LjC!, Text$)

  Rj$ = STR$(LjR!)
  Cj$ = STR$(LjC!)
  Sj$ = Esc$ + "&a" + Rj$ + "r" + Cj$ + "C" + Text$
  LPRINT Sj$

END SUB

FUNCTION RStr$ (A!)
  RStr$ = LTRIM$(STR$(A!))
END FUNCTION

