'
' MemLib Declarations File
' MemLib, EMSKit, XMSKit, MemSwap and MEMLIB.BI are
' Copyright InfoSoft, 1989-1991, 1992
'
'


' ---------- MemLib / EMSKit Declarations --------------
' --- setup and initialization routines ---
DECLARE FUNCTION EMSInstalled%
DECLARE FUNCTION EMSVersion% (maj%, min%)
DECLARE FUNCTION EMSStat%
DECLARE FUNCTION EMSPageAvail% (pages%)
DECLARE FUNCTION EMSPageFree% (pages%)
DECLARE FUNCTION EMSActiveHCnt% (HCnt%)
DECLARE FUNCTION EMSMaxHCnt% (HCnt%)



' --- memory management routines ---
DECLARE FUNCTION EMSMAlloc% (pages%, Handle%)
DECLARE FUNCTION EMSMRelease% (Handle%)
DECLARE FUNCTION EMSHandleSize% (Handle%, size%)
DECLARE FUNCTION EMSPutArray% (SEG Array AS ANY, ASize&, Handle%)
DECLARE FUNCTION EMSGetArray% (SEG Array AS ANY, ASize&, Handle%)
DECLARE FUNCTION EMSModHandle% (pages%, Handle%)
DECLARE FUNCTION EMSItemFetch% (SEG item AS ANY, place%, size%, EMSHandle%)
DECLARE FUNCTION EMSItemStore% (SEG item AS ANY, place%, size%, EMSHandle%)


' --- EMS support routines ----
DECLARE FUNCTION EMSHAttrGet% (Handle%, attr%)
DECLARE FUNCTION EMSHAttrSet% (Handle%, attr%)
DECLARE FUNCTION EMSAttrType% (attr%)
DECLARE FUNCTION EMSBootPrep%
DECLARE FUNCTION EMSHNameGet% (h%, n$)
DECLARE FUNCTION EMSHNameSet% (h%, n$)
DECLARE FUNCTION EMSHSearch% (n$, Handle%)
DECLARE FUNCTION EMSPHTable% (SEG ptr%)


' ---------- MemLib / XMSKit Declarations --------------
' --- status an initialization routines ---
DECLARE FUNCTION XMSInstalled% ()
DECLARE FUNCTION XMSAvail% ()
DECLARE FUNCTION XMSVersion% (HMA%)
DECLARE FUNCTION XMSHFree% ()
DECLARE FUNCTION XMSHSize% (XMsH%)


' --- memory management ---
DECLARE FUNCTION XMSAlloc% (kb%)
DECLARE FUNCTION XMSRelease% (XMsH%)
DECLARE FUNCTION XMSGetError% ()
DECLARE FUNCTION XMSMoveBlock% (SEG XMS AS ANY)
DECLARE FUNCTION XMSScrnSave ()
DECLARE FUNCTION XMSScrnRest (XMsH%)
DECLARE FUNCTION XMSLockH& (XMsH%)
DECLARE FUNCTION XMSUnLockH (XMsH%)
DECLARE FUNCTION XMSLockCount (XMsH%)


' --- support routines ---
DECLARE FUNCTION XMSClrError% ()
DECLARE FUNCTION XMSAddress& (SEG item AS ANY)
DECLARE FUNCTION XMSByteSize& (Low%, Hi%, size%)
DECLARE FUNCTION XMSDerefAddr (Addr&, SegVal%, OffsVal%)

' --- XMSBlockMove structure definition ---
TYPE XMSStruct
    Bytes AS LONG               ' even number of bytes to move

    SrcH AS INTEGER             ' source handle (DOS = 0)
    SrcAddr AS LONG             ' 32 bit address of the destination

    DstH AS INTEGER             ' Dst handle (DOS = 0)
    DstAddr AS LONG             ' 32 bit address of the destination
END TYPE

' --- EZ Move subs - Easy to use, but less flixibility ---
DECLARE FUNCTION FromXMS% (DataArray%(), Lo%, Hi%, XMsH%, XMS AS ANY)
DECLARE FUNCTION ToXMS% (DataArray%(), Lo%, Hi%, XMsH%, XMS AS ANY)


' ---------- MemLib / MemSwap Declarations --------------
DECLARE FUNCTION MemSwapDsk% (RunPrg$, CmdLine$, ChildRetC%, SwapFile$)
DECLARE FUNCTION MemSwapEMS% (RunPrg$, CmdLine$, ChildRetC%)
DECLARE FUNCTION MemSwapXMS% (RunPrg$, CmdLine$, ChildRetC%)

