@ECHO OFF
CLS
ECHO  MOUSE.BAT ͻ
ECHO                                                                     
ECHO  This batch file creates a QuickBASIC compatible library (LIB)      
ECHO  and QuickLibrary (QLB) that SUPPORTS MOUSE FUNCTIONS.              
ECHO                                                                     
ECHO  To make use of this library, you must load BASIC EXACTLY as        
ECHO  follows:                                                           
ECHO                                                                     
ECHO         QB /AH /L LITELIB.QLB                                       
ECHO                                                                     
ECHO ͼ

PAUSE
IF EXIST LITELIB.LIB DEL LITELIB.LIB

:makelib
LIB LITELIB +LITE.LIB+ADDMOUSE.LIB;
IF ERRORLEVEL GT 0 GOTO fail
IF EXIST LITELIB.LIB GOTO makeqlb
ECHO 
ECHO Error creating LIB file
ECHO 
GOTO fail

:makeqlb
LINK /Q /NOE +LITELIB.LIB,,,BQLB45;
IF ERRORLEVEL GT 0 GOTO fail
IF EXIST LITELIB.QLB GOTO success
ECHO 
ECHO Error creating QLB file
ECHO 
GOTO fail

:success
ECHO  REMEMBER ͻ
ECHO                                                                     
ECHO  To make use of this library, you must load BASIC EXACTLY as        
ECHO  follows:                                                           
ECHO                                                                     
ECHO         QB /AH /L LITELIB.QLB                                       
ECHO                                                                     
ECHO ͼ
ECHO Ŀ
ECHO  DONE.....                                                          
ECHO 

:fail
