ECHO OFF
:MENU
CLS
ECHO           Ŀ
ECHO                 The QBRENUM Demonstration Batch Utility       
ECHO                 (C) Copyright 1988-1991 Richard Z. Ward       
ECHO                            All Rights Reserved                
ECHO           
ECHO              Ŀ
ECHO               In each demonstration run, both the input and 
ECHO               output files will be displayed side-by-side.  
ECHO              
LINEFEED
ECHO              Quick BASIC Renumber Utility Command Line Options
LINEFEED
ECHO                        1- Renumber file including comments (/C)
ECHO                        2- Insert line numbers (/CI)
ECHO                        3- Pre-process metacommands (/CM)
ECHO                        4- Relax line numbering constraints (/CR)
ECHO                        5- Strip line numbers (/CS)
ECHO                        6- Take out extra spaces (/CIT)
ECHO                        7- Exclude Renumbering (/XIT)
ECHO                        8- Exit to DOS
LINEFEED
QBRASK "                          Choice: ",12345678
IF ERRORLEVEL 8 GOTO END
IF ERRORLEVEL 7 GOTO X
IF ERRORLEVEL 6 GOTO T
IF ERRORLEVEL 5 GOTO S
IF ERRORLEVEL 4 GOTO R
IF ERRORLEVEL 3 GOTO M
IF ERRORLEVEL 2 GOTO I
CLS
ECHO              Ŀ
ECHO               QBRENUM will renumber all lines with a default
ECHO               line increment of 10.  It will replace the    
ECHO               first line number with line 10 and continue.  
ECHO               It will also renumber commented lines of code.
ECHO              
LINEFEED
ECHO Ŀ
ECHO  QBRENUM SAMPLE /C  
ECHO 
QBRENUM SAMPLE /C
PAUSE
CLS
ECHO Ŀ
ECHO  QBRENUM SAMPLE /C  
ECHO 
QBRSS SAMPLE.BAS SAMPLE.RNM /C
PAUSE
GOTO MENU
:T
CLS
ECHO              Ŀ
ECHO               QBRENUM will renumber all lines, replacing the
ECHO               first with 10 and incrementing by 10. Further,
ECHO               QBRENUM will insert line numbers before non-  
ECHO               numbered lines and take away any extra spaces 
ECHO               found between the new line number and code.   
ECHO              
LINEFEED
ECHO Ŀ
ECHO  QBRENUM SAMPLE /CIT 
ECHO 
QBRENUM SAMPLE /CIT
PAUSE
CLS
ECHO Ŀ
ECHO  QBRENUM SAMPLE /CIT 
ECHO 
QBRSS SAMPLE.BAS SAMPLE.RNM /C
PAUSE
GOTO MENU
:S
CLS
ECHO           Ŀ
ECHO            QBRENUM will renumber all lines, replacing the first
ECHO            with 10 and incrementing by 10.  Also, QBRENUM will 
ECHO            remove all non-referenced line numbers found.       
ECHO 
ECHO  QBRENUM SAMPLE /CS 
ECHO 
QBRENUM SAMPLE /CS
PAUSE
CLS
ECHO Ŀ
ECHO  QBRENUM SAMPLE /CS 
ECHO 
QBRSS SAMPLE.BAS SAMPLE.RNM /C
PAUSE
GOTO MENU
:R
CLS
ECHO           Ŀ
ECHO            QBRENUM will renumber lines 10-40, replacing line 10
ECHO            with 15 and incrementing by 1.  Also, QBRENUM will  
ECHO            renumber include files and not check for order (/R).
ECHO           
ECHO Ŀ
ECHO  QBRENUM SAMPLE 15,10,40,1 /CR 
ECHO 
QBRENUM SAMPLE 15,10,40,1 /CR
PAUSE
CLS
ECHO Ŀ
ECHO  QBRENUM SAMPLE 15,10,40,1 /CR 
ECHO 
QBRSS SAMPLE.BAS SAMPLE.RNM /C
PAUSE
GOTO MENU
:M
CLS
ECHO           Ŀ
ECHO            QBRENUM will renumber lines 40-80, replacing line 40
ECHO            with 40 and incrementing by 5.  It will renumber    
ECHO            include file SAMPLE2.BAS and commented lines.       
ECHO           
ECHO Ŀ
ECHO  QBRENUM SAMPLE 40,40,150,5 /CM 
ECHO 
PAUSE
QBRENUM SAMPLE 40,40,150,5 /CM
PAUSE
CLS
ECHO Ŀ
ECHO  QBRENUM SAMPLE 40,40,150,5 /CM 
ECHO 
QBRSS SAMPLE.BAS SAMPLE.RNM /C
PAUSE
QBRSS SAMPLE2.BAS SAMPLE2.RNM /C
PAUSE
GOTO MENU
:I
CLS
ECHO           Ŀ
ECHO            QBRENUM will renumber all lines, insert line numbers
ECHO            before non-indexed lines, and renumber commented    
ECHO            lines of code.  Look at REMarked statements.        
ECHO           
ECHO Ŀ
ECHO  QBRENUM SAMPLE /CI 
ECHO 
QBRENUM SAMPLE /CI
PAUSE
CLS
ECHO Ŀ
ECHO  QBRENUM SAMPLE /CI 
ECHO 
QBRSS SAMPLE.BAS SAMPLE.RNM /C
PAUSE
GOTO MENU
:X
CLS
ECHO           Ŀ
ECHO            QBRENUM will not renumber any lines.  Instead, it   
ECHO            will only insert line numbers before non-indexed    
ECHO            lines of code.                                      
ECHO           
ECHO Ŀ
ECHO  QBRENUM SAMPLE /XIT 
ECHO 
QBRENUM SAMPLE /XIT
PAUSE
CLS
ECHO Ŀ
ECHO  QBRENUM SAMPLE /XIT 
ECHO 
QBRSS SAMPLE.BAS SAMPLE.RNM /C
PAUSE
GOTO MENU
:END
