'***** QBXDBF ver 1.00 declarations *****
'standard functions
DECLARE FUNCTION AddKeyDBF% (kyfile%, recordno&, vseg%, voff%)
DECLARE FUNCTION AddRecordDBF% (dbfile%, vseg%, voff%, recordno&)
DECLARE FUNCTION CloseDataDBF% (dbfile%)
DECLARE FUNCTION CloseKeyDBF% (kyfile%)
DECLARE FUNCTION CopyDataStrucDBF% (dbfile%, copyfile$)
DECLARE FUNCTION CopyKeyStrucDBF% (kyfile%, copyfile$)
DECLARE FUNCTION CreateDataDBF% (filename$, NoFields%, FieldList() AS ANY)
DECLARE FUNCTION CreateKeyDBF% (filename$, kx$, dbfile%)
DECLARE FUNCTION DeleteRecordDBF% (dbfile%, recordno&)
DECLARE FUNCTION ExitDBF% ()
DECLARE FUNCTION ExpandDataDBF% (dbfile%, norecs&)
DECLARE FUNCTION ExpandKeyDBF% (kyfile%, nokeys&)
DECLARE FUNCTION FlushDataDBF% (dbfile%, dup%)
DECLARE FUNCTION FlushKeyDBF% (kyfile%, dup%)
DECLARE FUNCTION FreeDataFileDBF% ()
DECLARE FUNCTION FreeKeyFileDBF% ()
DECLARE FUNCTION GetCurrKeyDBF% (kyfile%, Qkey$)
DECLARE FUNCTION GetDirectDBF% (dbfile%, recordno&, vseg%, voff%)
DECLARE FUNCTION GetEqualDBF% (kyfile%, dbfile%, Qkey$, vseg%, voff%)
DECLARE FUNCTION GetFirstDBF% (kyfile%, dbfile%, vseg%, voff%)
DECLARE FUNCTION GetGTDBF% (kyfile%, dbfile%, Qkey$, vseg%, voff%)
DECLARE FUNCTION GetGTEDBF% (kyfile%, dbfile%, Qkey$, vseg%, voff%)
DECLARE FUNCTION GetLastDBF% (kyfile%, dbfile%, vseg%, voff%)
DECLARE FUNCTION GetLTDBF% (kyfile%, dbfile%, Qkey$, vseg%, voff%)
DECLARE FUNCTION GetLTEDBF% (kyfile%, dbfile%, Qkey$, vseg%, voff%)
DECLARE FUNCTION GetNextDBF% (kyfile%, dbfile%, vseg%, voff%)
DECLARE FUNCTION GetPositionDBF% (kyfile%, recordno&)
DECLARE FUNCTION GetPrevDBF% (kyfile%, dbfile%, vseg%, voff%)
DECLARE FUNCTION InitDBF% (KEYfiles%, DBFfiles%, DBFfields%)
DECLARE FUNCTION MKN$ (dbfile%, FieldNumber%, zNum#, errc%)
'PDS-DECLARE FUNCTION MKN$ (dbfile%, FieldNumber%, zNum@, errc%)
DECLARE FUNCTION OpenDataDBF% (filename$, dbfile%, asmode%)
DECLARE FUNCTION OpenKeyDBF% (filename$, kyfile%, dbfile%, asmode%)
DECLARE FUNCTION StatDataDBF% (dbfile%, RecLen%, norecs&, bfileno%, NoFields%, LUdate$, ID%)
DECLARE FUNCTION StatKeyDBF% (kyfile%, keylen%, keys&, bfileno%)
DECLARE FUNCTION UndeleteRecordDBF% (dbfile%, recordno&)
DECLARE FUNCTION UpdateRecordDBF% (dbfile%, recordno&, vseg%, voff%)
DECLARE FUNCTION VersionDBF% (version$)
'-----STANDARD EXTERNAL-----
DECLARE FUNCTION PackDBF% (dbfile%, kyfile%, packfile$, keyfile$)
DECLARE FUNCTION ReIndexDBF% (kyfile%, dbfile%, NewKeyFile$)
'-----LOW-LEVEL-----
DECLARE FUNCTION GetKeyExpressionDBF% (kyfile%, kx$)
DECLARE FUNCTION GetKeyAtPosDBF% (kyfile%, keyat$)
DECLARE FUNCTION ConstructQkeyDBF% (kyfile%, Qkey$, vseg%, voff%, keylen%)
DECLARE FUNCTION GetFieldDBF% (dbfile%, FieldNo%, FieldList AS ANY)
DECLARE FUNCTION GetHeaderDBF% (dbfile%, HeaderList AS ANY)
DECLARE FUNCTION SetFieldDBF% (dbfile%, FieldNo%, FieldList AS ANY)
DECLARE FUNCTION SetHeaderDBF% (dbfile%, HeaderList AS ANY)
DECLARE FUNCTION ReadHeaderDBF% (dbfile%)
DECLARE FUNCTION WriteHeaderDBF% (dbfile%)
DECLARE FUNCTION ReadFieldDescDBF% (dbfile%)
DECLARE FUNCTION WriteFieldDescDBF% (dbfile%)
DECLARE FUNCTION ProcessExpressionDBF$ (express$, errc%, maxvar%, maxsub%)
DECLARE FUNCTION GetTreeState% (kyfile%, TreeState AS ANY)
'---- UTILITY ----
DECLARE SUB GetDiskInfo (drive$, AvailClusters%, MaxClusters%, BytesSector%, SectorsCluster%, freebytes&)
DECLARE FUNCTION GetDefaultDrive% ()
DECLARE FUNCTION FileExists% (filename$)
DECLARE FUNCTION GetDosVersion% ()
DECLARE FUNCTION SFTFiles% ()
DECLARE FUNCTION GetXEInfo% (class%, action%, locus%)
'----- UTILITY EXTERNAL ----
DECLARE FUNCTION CreateFile% (pathname$, BYVAL attribute%)
DECLARE FUNCTION OpenDevice% (pathname$, BYVAL asmode%, handle%, flen&)
DECLARE FUNCTION ReadDevice% (BYVAL handle%, BYVAL start&, BYVAL bytes&, BYVAL vseg%, BYVAL voff%)
DECLARE FUNCTION WriteDevice% (BYVAL handle%, BYVAL start&, BYVAL bytes&, BYVAL vseg%, BYVAL voff%)
DECLARE FUNCTION CloseDevice% (BYVAL handle%)
DECLARE FUNCTION DeleteFile% (pathname$)
DECLARE FUNCTION RenameFile% (oldpathname$, newpathname$)
'---- INTERNAL USE ----
DECLARE FUNCTION RetrieveFirst% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrievePrev% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveEqual% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveNext% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveLast% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveGT% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveGTE% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveLT% (kfile%, Qkey2$, Qrecno&)
DECLARE FUNCTION RetrieveLTE% (kfile%, Qkey2$, Qrecno&)
'---- INTERNAL USE EXTERNAL ----
DECLARE FUNCTION MemComp% (BYVAL vseg1%, BYVAL voff1%, BYVAL vseg2%, BYVAL voff2%, BYVAL bytes%)
DECLARE SUB MemCopy (BYVAL FromSeg%, BYVAL FromOff%, BYVAL ToSeg%, BYVAL ToOff%, BYVAL count%)
DECLARE SUB QuikSort (BYVAL vseg%, BYVAL voff%, BYVAL Items%, BYVAL RecLen%, BYVAL cstart%, BYVAL cbytes%)

'--------------------------------------------------------------------------
'{Prg-level structure used to get/set each field in a db record}

TYPE DBFFieldListTYPE
FieldName AS STRING * 10
FieldType AS STRING * 1
FieldLen AS INTEGER
FieldDC AS INTEGER
END TYPE '15

TYPE TreeStateTYPE
ackysc AS LONG
cukysc AS LONG
cukyof AS INTEGER
iflag AS INTEGER
stkcnt AS INTEGER
pstack AS STRING * 40
END TYPE '54 -- allocated in caller program, internal use only


