;
;TITLE: Scroll86.asm    Jan 16, 1991

Stack          STRUC
Bpsav          DW       ?                       ;saved by us
Retoff         DW       ?                       ;from callf
Retseg         DW       ?                       ;from basic
InArray_off    DW       ?                       ;pointer to array in far heap
InArray_seg    DW       ?                       ;pointer to array in far heap
Stack          ENDS

Basic_setup    MACRO
               PUSH     BP
               MOV      BP,SP

               PUSH     BX
               PUSH     SI
               PUSH     DI
               PUSH     DS
               PUSH     ES
               ENDM

Basic_cleanup  MACRO
               POP      ES
               POP      DS
               POP      DI
               POP      SI
               POP      BX

               POP      BP
               ENDM

;
;CODE      SEGMENT BYTE PUBLIC ;CODE;
;          ASSUME CS:CODE

Dosseg                                          ;requires masm 5.0 or higher
               .Model Medium

;       Define all publicly accessible routines.
               PUBLIC   SCROLL86

               .Code

Scroll86       PROC     FAR

               Basic_setup

               MOV      SI,[BP].InArray_off       ;get location of array offset
               MOV      SI,[SI]
               MOV      BX,[BP].InArray_seg       ;get location to array segment
               MOV      DS,[BX]                   ;segment address of array

                                                  ;Service goes in AH register
               MOV      AX,[SI]                   ;Lines goes in AL register
               MOV      BX,[SI+2]                 ;BH = Color Attribute of window
               MOV      CX,[SI+4]                 ;CH=ULR, CL=ULC
               MOV      DX,[SI+6]                 ;DH=LRR, DL=LRC

               INT      10H

               Basic_cleanup

               RET      4d

Scroll86       ENDP

;CODE          ENDS
               END
