;RM82TS8,16,24,32,40,48,56,64
; updated 5/14/91

;============================================================================
;   Copyright (C) Copr. 1991 by Sidney J. Kelly
;           All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;============================================================================

DOSSEG
.MODEL MEDIUM, BASIC
.CODE

;=======================================================================
; DECLARE FUNCTION INCOLOR%()
;       IF INCOLOR% THEN
;           ... etc.
; Tests if have a color or mono display attached
; returns          -1 if color dsplay (may be a single color display)
;                   0 if BW mono display
; Note will not be fooled by Herc CGA emulation routines.
;
; Version 0.32
;=======================================================================

EVEN
INCOLOR PROC FAR
	Xor     AX,AX           ; Assume a Mono Display
	Mov     ES,AX           ; set ES to Ram BIOS area
	Mov     BX,ES:[0463h]   ; look a port info stored in RAM bios
				; at 0000:0463h
	Cmp     BL,0B4h         ; Mono reports 0B4h, color 0D4h
	Je      Done            ; test port address, if Mono then quit
	Mov     AX,-1           ; else report have COLOR adapter
Done:
	Ret
INCOLOR ENDP
END
